## glibc 2.41

=== assert/Makefile ===
# Copyright (C) 1991-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for assert portion of the library.
#
subdir	:= assert

include ../Makeconfig

headers := \
  assert.h
  # headers

routines := \
  __assert \
  __libc_assert_fail \
  assert \
  assert-perr \
  # routines

tests := \
  test-assert \
  test-assert-2 \
  test-assert-perr \
  tst-assert-c++ \
  tst-assert-g++ \
  # tests

ifeq ($(have-cxx-thread_local),yes)
CFLAGS-tst-assert-c++.o = -std=c++11
LDLIBS-tst-assert-c++ = -lstdc++
CFLAGS-tst-assert-g++.o = -std=gnu++11
LDLIBS-tst-assert-g++ = -lstdc++
else
tests-unsupported += \
  tst-assert-c++ \
  tst-assert-g++ \
  # tests-unsupported
endif

include ../Rules

=== benchtests/Makefile ===
# Copyright (C) 2013-2025 Free Software Foundation, Inc.
# Copyright The GNU Toolchain Authors.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

# Makefile for benchmark tests.  The only useful target here is `bench`.
# Add benchmark functions in alphabetical order.

subdir := benchtests

include ../Makeconfig

bench-math := \
  acos \
  acosf \
  acosh \
  acoshf \
  asin \
  asinf \
  asinh \
  asinhf \
  atan \
  atan2 \
  atan2f \
  atanf \
  atanh \
  atanhf \
  cbrt \
  cbrtf \
  ceil \
  ceilf \
  cos \
  cosf \
  cosh \
  coshf \
  erf \
  erfc \
  erfcf \
  erff \
  exp \
  exp10 \
  exp10f \
  exp10m1f \
  exp2 \
  exp2f \
  exp2m1f \
  expf \
  expm1 \
  expm1f \
  floor \
  floorf \
  fmax \
  fmaxf \
  fmin \
  fminf \
  fmod \
  fmodf \
  hypot \
  hypotf \
  ilogb \
  ilogbf \
  isfinite \
  isinf \
  isnan \
  j0 \
  j1 \
  lgamma \
  lgammaf \
  llrint \
  llrintf \
  log \
  log10 \
  log10f \
  log10p1f \
  log1p \
  log1pf \
  log2 \
  log2f \
  log2p1f \
  logb \
  logbf \
  logf \
  lrint \
  lrintf \
  modf \
  nearbyint \
  nearbyintf \
  pow \
  powf \
  rint \
  rintf \
  roundeven \
  roundevenf \
  sin \
  sincos \
  sincosf \
  sinf \
  sinh \
  sinhf \
  sqrt \
  tan \
  tanf \
  tanh \
  tanhf \
  tgamma \
  tgammaf \
  trunc \
  truncf \
  y0 \
  y1 \
  # bench-math

ifneq (,$(filter yes,$(float96-fcts)))
bench-math += \
  cbrtl \
  # bench-math
endif

ifneq (,$(filter yes,$(float128-fcts) $(float128-alias-fcts)))
bench-math += \
  expf128 \
  ilogbf128 \
  powf128 \
  sinf128 \
  # bench-math
endif

bench-pthread := \
  pthread-locks \
  pthread-mutex-lock \
  pthread-mutex-trylock \
  pthread-spin-lock \
  pthread-spin-trylock \
  pthread_once \
  thread_create \
  # bench-pthread

LDLIBS-bench-pthread-mutex-lock += -lm
LDLIBS-bench-pthread-mutex-trylock += -lm
LDLIBS-bench-pthread-spin-lock += -lm
LDLIBS-bench-pthread-spin-trylock += -lm

bench-string := \
  ffs \
  ffsll \
  # bench-string

# String function benchmarks.
string-benchset := \
  bzero \
  bzero-large \
  memccpy \
  memchr \
  memcmp \
  memcmpeq \
  memcpy \
  memcpy-large \
  memcpy-random \
  memmem \
  memmove \
  memmove-large \
  mempcpy \
  memrchr \
  memset \
  memset-large \
  memset-random \
  memset-zero \
  memset-zero-large \
  rawmemchr \
  stpcpy \
  stpcpy_chk \
  stpncpy \
  strcasecmp \
  strcasestr \
  strcat \
  strchr \
  strchrnul \
  strcmp \
  strcoll \
  strcpy \
  strcpy_chk \
  strcspn \
  strlen \
  strncasecmp \
  strncat \
  strncmp \
  strncpy \
  strnlen \
  strpbrk \
  strrchr \
  strsep \
  strspn \
  strstr \
  strtok \
  # string-benchset

# Build and run locale-dependent benchmarks only if we're building natively.
ifeq (no,$(cross-compiling))
wcsmbs-benchset := \
  wcpcpy \
  wcpncpy \
  wcrtomb \
  wcscat \
  wcschr \
  wcschrnul \
  wcscmp \
  wcscpy \
  wcscspn \
  wcslen \
  wcsncat \
  wcsncmp \
  wcsncpy \
  wcsnlen \
  wcspbrk \
  wcsrchr \
  wcsspn \
  wmemchr \
  wmemcmp \
  wmemset \
  # wcsmbs-benchset
else
wcsmbs-benchset :=
endif

string-benchset-all := $(string-benchset) ${wcsmbs-benchset}

ifeq (no,$(cross-compiling))
# We have to generate locales
LOCALES := \
  ar_SA.UTF-8 \
  cs_CZ.UTF-8 \
  da_DK.UTF-8 \
  el_GR.UTF-8 \
  en_GB.UTF-8 \
  en_US.UTF-8 \
  es_ES.UTF-8 \
  fa_IR.UTF-8 \
  fr_FR.UTF-8 \
  he_IL.UTF-8 \
  hi_IN.UTF-8 \
  hu_HU.UTF-8 \
  is_IS.UTF-8 \
  it_IT.UTF-8 \
  ja_JP.UTF-8 \
  pl_PL.UTF-8 \
  pt_PT.UTF-8 \
  ru_RU.UTF-8 \
  si_LK.UTF-8 \
  sr_RS.UTF-8 \
  sv_SE.UTF-8 \
  tr_TR.UTF-8 \
  vi_VN.UTF-8 \
  zh_CN.UTF-8 \
  # LOCALES
include ../gen-locales.mk
endif

hash-benchset := \
  dl-elf-hash \
  dl-new-hash \
  nss-hash \
  # hash-benchset

stdlib-benchset := \
  arc4random \
  bsearch \
  random-lock \
  strtod \
  # stdlib-benchset

stdio-benchset := \
  fclose \
  # stdio-benchset

stdio-common-benchset := sprintf

math-benchset := math-inlines

ifeq (${BENCHSET},)
benchset := \
  $(hash-benchset) \
  $(math-benchset) \
  $(stdio-benchset) \
  $(stdio-common-benchset) \
  $(stdlib-benchset) \
  $(string-benchset-all) \
  # benchset
else
benchset := $(foreach B,$(filter %-benchset,${BENCHSET}), ${${B}})
endif

CFLAGS-bench-ffs.c += -fno-builtin
CFLAGS-bench-ffsll.c += -fno-builtin
CFLAGS-bench-sqrt.c += -fno-builtin
CFLAGS-bench-fmin.c += -fno-builtin
CFLAGS-bench-fminf.c += -fno-builtin
CFLAGS-bench-fmax.c += -fno-builtin
CFLAGS-bench-fmaxf.c += -fno-builtin
CFLAGS-bench-trunc.c += -fno-builtin
CFLAGS-bench-truncf.c += -fno-builtin
CFLAGS-bench-roundeven.c += -fno-builtin
CFLAGS-bench-roundevenf.c += -fno-builtin
CFLAGS-bench-isnan.c += $(config-cflags-signaling-nans)
CFLAGS-bench-isinf.c += $(config-cflags-signaling-nans)
CFLAGS-bench-isfinite.c += $(config-cflags-signaling-nans)

ifeq (${BENCHSET},)
bench-malloc := \
  calloc-simple \
  calloc-thread \
  malloc-simple \
  malloc-thread \
  # bench-malloc
else
bench-malloc := $(filter malloc-%,${BENCHSET})
bench-malloc += $(filter calloc-%,${BENCHSET})
endif

ifeq (${STATIC-BENCHTESTS},yes)
+link-benchtests = $(+link-static-tests)
link-libc-benchtests = $(link-libc-static)
libm-benchtests = $(common-objpfx)math/libm.a
thread-library-benchtests = $(static-thread-library)
else
link-libc-benchtests = $(link-libc)
+link-benchtests = $(+link-tests)
thread-library-benchtests = $(shared-thread-library)
libm-benchtests = $(libm)
endif

$(addprefix $(objpfx)bench-,$(bench-math)): $(libm-benchtests)
$(addprefix $(objpfx)bench-,$(math-benchset)): $(libm-benchtests)
$(addprefix $(objpfx)bench-,$(bench-pthread)): $(thread-library-benchtests)
$(addprefix $(objpfx)bench-,$(bench-malloc)): $(thread-library-benchtests)
$(addprefix $(objpfx)bench-,pthread-locks): $(libm-benchtests)
$(addprefix $(objpfx)bench-,pthread-mutex-locks): $(libm-benchtests)



# Rules to build and execute the benchmarks.  Do not put any benchmark
# parameters beyond this point.

# We don't want the benchmark programs to run in parallel since that could
# affect their performance.
.NOTPARALLEL:

bench-extra-objs = json-lib.o

extra-objs += $(bench-extra-objs)
others-extras = $(bench-extra-objs)

# The default duration: 1 seconds.
ifndef BENCH_DURATION
BENCH_DURATION := 1
endif

CPPFLAGS-nonlib += -DDURATION=$(BENCH_DURATION) -D_ISOMAC

# Use clock_gettime to measure performance of functions.  The default is
# to use the architecture-specific high precision timing instructions.
ifdef USE_CLOCK_GETTIME
CPPFLAGS-nonlib += -DUSE_CLOCK_GETTIME
else
# On x86 processors, use RDTSCP, instead of RDTSC, to measure performance
# of functions.  All x86 processors since 2010 support RDTSCP instruction.
ifdef USE_RDTSCP
CPPFLAGS-nonlib += -DUSE_RDTSCP
endif
endif

DETAILED_OPT :=

ifdef DETAILED
DETAILED_OPT := -d
endif

bench-deps := bench-skeleton.c bench-timing.h Makefile

run-bench = $(test-wrapper-env) \
	    $(run-program-env) \
	    $($*-ENV) $(test-via-rtld-prefix) $${run}

timing-type := $(objpfx)bench-timing-type
extra-objs += bench-timing-type.o

include ../Rules

bench-math += $(bench-libmvec)

ifeq (${BENCHSET},)
bench := \
  $(bench-math) \
  $(bench-pthread) \
  $(bench-string) \
  # bench
else
bench := $(foreach B,$(filter bench-%,${BENCHSET}), ${${B}})
endif

# NB: Use "=" instead of ":=" since sysdeps Makefiles may add more
# benches.
binaries-bench = $(addprefix $(objpfx)bench-,$(bench))
extra-objs += $(addsuffix .o,$(addprefix bench-,$(bench)))
binaries-benchset = $(addprefix $(objpfx)bench-,$(benchset))
extra-objs += $(addsuffix .o,$(addprefix bench-,$(benchset)))
binaries-bench-malloc := $(addprefix $(objpfx)bench-,$(bench-malloc))
extra-objs += $(addsuffix .o,$(addprefix bench-,$(bench-malloc)))

# This makes sure CPPFLAGS-nonlib and CFLAGS-nonlib are passed
# for all these modules.
cpp-srcs-left := \
  $(binaries-bench-malloc:=.c) \
  $(binaries-bench:=.c) \
  $(binaries-benchset:=.c) \
  $(timing-type:=.c) \
  # cpp-srcs-left
lib := nonlib
include $(patsubst %,$(..)libof-iterator.mk,$(cpp-srcs-left))

bench-clean:
	rm -f $(binaries-bench) $(addsuffix .o,$(binaries-bench))
	rm -f $(binaries-benchset) $(addsuffix .o,$(binaries-benchset))
	rm -f $(binaries-bench-malloc) $(addsuffix .o,$(binaries-bench-malloc))
	rm -f $(timing-type) $(addsuffix .o,$(timing-type))
	rm -f $(addprefix $(objpfx),$(bench-extra-objs))

# Validate the passed in BENCHSET
ifneq ($(strip ${BENCHSET}),)
VALIDBENCHSETNAMES := \
  bench-math \
  bench-pthread \
  bench-string \
  calloc-simple \
  calloc-thread \
  hash-benchset \
  malloc-simple \
  malloc-thread \
  math-benchset \
  stdio-benchset \
  stdio-common-benchset \
  stdlib-benchset \
  string-benchset \
  wcsmbs-benchset \
  # VALIDBENCHSETNAMES

INVALIDBENCHSETNAMES := $(filter-out ${VALIDBENCHSETNAMES},${BENCHSET})
ifneq (${INVALIDBENCHSETNAMES},)
$(info The following values in BENCHSET are invalid: ${INVALIDBENCHSETNAMES})
$(info The valid ones are: ${VALIDBENCHSETNAMES})
$(error Invalid BENCHSET value)
endif
endif

bench: bench-build bench-set bench-func bench-malloc

# Target to only build the benchmark without running it.  We generate locales
# only if we're building natively.
ifeq (no,$(cross-compiling))
bench-build: $(gen-locales) $(timing-type) $(binaries-bench) \
	$(binaries-benchset) $(binaries-bench-malloc)
else
bench-build: $(timing-type) $(binaries-bench) $(binaries-benchset) \
	$(binaries-bench-malloc)
endif

bench-set: $(binaries-benchset)
	for run in $^; do \
	  echo "Running $${run}"; \
	  $(run-bench) > $${run}.out; \
	done

bench-malloc: $(binaries-bench-malloc)
	for run in $^; do \
	  echo "$${run}"; \
	  if [[ `basename $${run}` =~ bench-[cm]alloc-thread ]]; then \
		for thr in 1 8 16 32; do \
			echo "Running $${run} $${thr}"; \
			$(run-bench) $${thr} > $${run}-$${thr}.out; \
		done;\
	  else \
		for thr in 8 16 32 64 128 256 512 1024 2048 4096; do \
		  echo "Running $${run} $${thr}"; \
		  $(run-bench) $${thr} > $${run}-$${thr}.out; \
		done;\
	  fi;\
	done

# Build and execute the benchmark functions.  This target generates JSON
# formatted bench.out.  Each of the programs produce independent JSON output,
# so one could even execute them individually and process it using any JSON
# capable language or tool.
bench-func: $(binaries-bench)
	if [ -n '$^' ] ; then \
	{ timing_type=$$($(test-wrapper-env) \
			 $(run-program-env) \
			 $(test-via-rtld-prefix) \
			 $(timing-type)); \
	  echo "{\"timing_type\": \"$${timing_type}\","; \
	  echo " \"functions\": {"; \
	  for run in $^; do \
	    op=$$($(run-bench) $(DETAILED_OPT)); \
	    ret=$$?; \
	    case "$${ret}" in \
	      77) \
	      echo "UNSUPPORTED $${run}: $${op}" >&2; \
		;; \
	      0) \
		echo "Running $${run}" >&2; \
		if [ "$${run}" != "$<" ]; then \
		  echo ","; \
		fi; \
		echo "$${op}"; \
		;; \
	      *) \
		echo "FAILED $${run}" >&2; \
		;; \
	    esac; \
	  done; \
	  echo; \
	  echo " }"; \
	  echo "}"; \
	  } > $(objpfx)bench.out-tmp; \
	  if [ -f $(objpfx)bench.out ]; then \
	    mv -f $(objpfx)bench.out $(objpfx)bench.out.old; \
	  fi; \
	  mv -f $(objpfx)bench.out-tmp $(objpfx)bench.out; \
	  $(PYTHON) scripts/validate_benchout.py $(objpfx)bench.out \
	  scripts/benchout.schema.json; \
	fi

ifeq ($(bind-now),yes)
link-bench-bind-now = -Wl,-z,now
endif

bench-link-targets = $(timing-type) $(binaries-bench) $(binaries-benchset) \
	$(binaries-bench-malloc)

=== conform/Makefile ===
# Copyright (C) 1999-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for conform portion of the library.
#
subdir	:= conform

include ../Makeconfig

conformtest-headers-data := $(wildcard data/*.h-data) \
			    $(wildcard data/*/*.h-data)

conformtest-standards := \
  ISO \
  ISO11 \
  ISO99 \
  POSIX \
  POSIX2008 \
  UNIX98 \
  XOPEN2K \
  XOPEN2K8 \
  XPG4 \
  XPG42 \
  # conformtest-standards
conformtest-headers-ISO := \
  assert.h \
  ctype.h \
  errno.h \
  float.h \
  limits.h \
  locale.h \
  math.h \
  setjmp.h \
  signal.h \
  stdarg.h \
  stddef.h \
  stdio.h \
  stdlib.h \
  string.h \
  time.h \
  # conformtest-headers-ISO
conformtest-headers-ISO99 := \
  $(conformtest-headers-ISO) \
  complex.h \
  fenv.h \
  inttypes.h \
  iso646.h \
  stdbool.h \
  stdint.h \
  tgmath.h \
  wchar.h \
  wctype.h \
  # conformtest-headers-ISO99
# Missing ISO11 expectations for: stdatomic.h
conformtest-headers-ISO11 := \
  $(conformtest-headers-ISO99) \
  stdalign.h \
  stdnoreturn.h \
  threads.h \
  uchar.h \
  # conformtest-headers-ISO11
conformtest-headers-POSIX := \
  $(conformtest-headers-ISO) \
  aio.h \
  dirent.h \
  fcntl.h \
  fnmatch.h \
  glob.h \
  grp.h \
  mqueue.h \
  pthread.h \
  pwd.h \
  regex.h \
  sched.h \
  semaphore.h \
  sys/mman.h \
  sys/stat.h \
  sys/times.h \
  sys/types.h \
  sys/utsname.h \
  sys/wait.h \
  tar.h \
  termios.h \
  unistd.h \
  utime.h \
  wordexp.h \
  # conformtest-headers-POSIX
# Missing XPG4 expectations for: regexp.h wchar.h.
conformtest-headers-XPG4 := \
  $(conformtest-headers-ISO) \
  cpio.h \
  dirent.h \
  fcntl.h \
  fnmatch.h \
  ftw.h \
  glob.h \
  grp.h \
  iconv.h \
  langinfo.h \
  monetary.h \
  nl_types.h \
  pwd.h \
  regex.h \
  search.h \
  sys/ipc.h \
  sys/msg.h \
  sys/sem.h \
  sys/shm.h \
  sys/stat.h \
  sys/times.h \
  sys/types.h \
  sys/utsname.h \
  sys/wait.h \
  tar.h \
  termios.h \
  ulimit.h \
  unistd.h \
  utime.h \
  varargs.h \
  wordexp.h \
  # conformtest-headers-XPG4
# Missing XPG42 expectations for:
#   re_comp.h
#   regexp.h
#   wchar.h
# XPG42 includes XTI and STREAMS, but those are not implemented by glibc.
conformtest-headers-XPG42 := \
  $(conformtest-headers-XPG4) \
  arpa/inet.h \
  fmtmsg.h \
  libgen.h \
  ndbm.h \
  netdb.h \
  netinet/in.h \
  poll.h \
  strings.h \
  sys/mman.h \
  sys/resource.h \
  sys/socket.h \
  sys/statvfs.h \
  sys/time.h \
  sys/timeb.h \
  sys/uio.h \
  sys/un.h \
  syslog.h \
  ucontext.h \
  utmpx.h \
  # conformtest-headers-XPG42
# Missing UNIX98 expectations for:
#   inttypes.h
#   re_comp.h
#   regexp.h
# The online UNIX98 includes XCURSES, but curses.h, term.h and
# unctrl.h are outside the scope of these tests.  It also includes
# XTI and STREAMS, but those are not implemented by glibc.
conformtest-headers-UNIX98 := \
  $(conformtest-headers-POSIX) \
  arpa/inet.h \
  cpio.h \
  dlfcn.h \
  fmtmsg.h \
  ftw.h \
  iconv.h \
  iso646.h \
  langinfo.h \
  libgen.h \
  monetary.h \
  ndbm.h \
  netdb.h \
  netinet/in.h \
  nl_types.h \
  poll.h \
  search.h \
  strings.h \
  sys/ipc.h \
  sys/msg.h \
  sys/resource.h \
  sys/sem.h \
  sys/shm.h \
  sys/socket.h \
  sys/statvfs.h \
  sys/time.h \
  sys/timeb.h \
  sys/uio.h \
  sys/un.h \
  syslog.h \
  ucontext.h \
  ulimit.h \
  utmpx.h \
  varargs.h \
  wchar.h \
  wctype.h \
  # conformtest-headers-UNIX98
# Missing XOPEN2K expectations for:
#   trace.h
#   stropts.h
conformtest-headers-XOPEN2K := \
  $(conformtest-headers-POSIX) \
  arpa/inet.h \
  complex.h \
  cpio.h \
  dlfcn.h \
  fenv.h \
  fmtmsg.h \
  ftw.h \
  iconv.h \
  inttypes.h \
  iso646.h \
  langinfo.h \
  libgen.h \
  monetary.h \
  ndbm.h \
  net/if.h \
  netdb.h \
  netinet/in.h \
  netinet/tcp.h \
  nl_types.h \
  poll.h \
  search.h \
  spawn.h \
  stdbool.h \
  stdint.h \
  strings.h \
  sys/ipc.h \
  sys/msg.h \
  sys/resource.h \
  sys/select.h \
  sys/sem.h \
  sys/shm.h \
  sys/socket.h \
  sys/statvfs.h \
  sys/time.h \
  sys/timeb.h \
  sys/uio.h \
  sys/un.h \
  syslog.h \
  tgmath.h \
  ucontext.h \
  ulimit.h \
  utmpx.h \
  wchar.h \
  wctype.h \
  # conformtest-headers-XOPEN2K
# Missing POSIX2008 expectations for:
#   trace.h
#   stropts.h
conformtest-headers-POSIX2008 := \
  $(conformtest-headers-POSIX) \
  arpa/inet.h \
  complex.h \
  cpio.h \
  dlfcn.h \
  fenv.h \
  iconv.h \
  inttypes.h \
  iso646.h \
  langinfo.h \
  monetary.h \
  net/if.h \
  netdb.h \
  netinet/in.h \
  netinet/tcp.h \
  nl_types.h \
  poll.h \
  spawn.h \
  stdbool.h \
  stdint.h \
  strings.h \
  sys/select.h \
  sys/socket.h \
  sys/statvfs.h \
  sys/un.h \
  tgmath.h \
  wchar.h \
  wctype.h \
  # conformtest-headers-POSIX2008
# Missing XOPEN2K8 expectations for:
#   trace.h
conformtest-headers-XOPEN2K8 := \
  $(conformtest-headers-POSIX2008) \
  fmtmsg.h \
  ftw.h \
  libgen.h \
  ndbm.h \
  search.h \
  sys/ipc.h \
  sys/msg.h \
  sys/resource.h \
  sys/sem.h \
  sys/shm.h \
  sys/time.h \
  sys/uio.h \
  syslog.h \
  ulimit.h \
  utmpx.h \
  # conformtest-headers-XOPEN2K8

conformtest-header-list-base := $(foreach std,$(conformtest-standards),\
					      header-list-$(std).out)
conformtest-header-list-tests := $(addprefix $(objpfx),\
					     $(conformtest-header-list-base))
tests-special += $(conformtest-header-list-tests)
generated += $(conformtest-header-list-base)

conformtest-header-base := $(foreach std,\
				     $(conformtest-standards),\
				     $(foreach h,\
					       $(conformtest-headers-$(std)),\
					       $(std)/$(h)/conform.out))
conformtest-header-tests := $(addprefix $(objpfx),$(conformtest-header-base))
ifneq (yes,$(fast-check))
tests-special += $(conformtest-header-tests)
generated += $(conformtest-header-base)
endif

linknamespace-symlists-base := $(foreach std,$(conformtest-standards),\
					     symlist-$(std))
linknamespace-symlists-tests := $(addprefix $(objpfx),\
					    $(linknamespace-symlists-base))
tests-special += $(linknamespace-symlists-tests)

linknamespace-symlist-stdlibs-base := $(foreach std,$(conformtest-standards),\
						    symlist-stdlibs-$(std))
linknamespace-symlist-stdlibs-tests := \
	$(addprefix $(objpfx),\
		    $(linknamespace-symlist-stdlibs-base))

tests-special += $(linknamespace-symlist-stdlibs-tests)

linknamespace-header-base := $(foreach std,\
				       $(conformtest-standards),\
				       $(foreach h,\
						 $(conformtest-headers-$(std)),\
						 $(std)/$(h)/linknamespace.out))
linknamespace-header-tests := $(addprefix $(objpfx),\
					  $(linknamespace-header-base))
tests-special += $(linknamespace-header-tests)

include ../Rules

$(conformtest-header-list-tests): $(objpfx)header-list-%.out: \
				  check-header-lists.sh \
				  $(conformtest-headers-data)
	$(SHELL) $< "$*" "$(CC)" "$(strip $(conformtest-headers-$*))" \
		 "$(conformtest-headers-data)" > $@; \
	$(evaluate-test)

# Pre-standard C feature no longer supported by GCC (obsoleted in
# newer POSIX standards).
test-xfail-XPG4/varargs.h/conform = yes
test-xfail-XPG42/varargs.h/conform = yes
test-xfail-UNIX98/varargs.h/conform = yes

# Header not provided by glibc.
test-xfail-XPG42/ndbm.h/conform = yes
test-xfail-UNIX98/ndbm.h/conform = yes
test-xfail-XOPEN2K/ndbm.h/conform = yes
test-xfail-XOPEN2K8/ndbm.h/conform = yes

conformtest-cc-flags =  -I../include $(+sysdep-includes) $(sysincludes) -I.. $(no-file-offset-bits-source) $(no-time-bits-source)
# conformtest-xfail-conds may be set by a sysdeps Makefile fragment to
# a list of conditions that are considered to be true when encountered
# in xfail[cond]- lines in test expectations.
conformtest-xfail = $(if $(conformtest-xfail-conds),\
			 --xfail='$(conformtest-xfail-conds)')
ifeq (no,$(cross-compiling))
conformtest-cross =
else
conformtest-cross = --cross
endif
$(conformtest-header-tests): $(objpfx)%/conform.out: \
			     conformtest.py $(conformtest-headers-data)
	(set -e; std_hdr=$*; std=$${std_hdr%%/*}; hdr=$${std_hdr#*/}; \
	 mkdir -p $(@D); \
	 $(PYTHON) $< --cc='$(CC) $(pie-default)' \
		   --flags='$(conformtest-cc-flags)' \
		   --ldflags='$(+link-tests-before-inputs)' \
		   --libs='$(+link-tests-after-inputs)' \
		   --run-program-prefix='$(run-program-prefix)' \
		   --standard=$$std --header=$$hdr $(conformtest-xfail) \
		   $(conformtest-cross) \
		   > $@ 2>&1); \
	$(evaluate-test)

$(linknamespace-symlists-tests): $(objpfx)symlist-%: list-header-symbols.py
	$(PYTHON) $< --cc='$(CC)' --flags='$(conformtest-cc-flags)' \
		  --standard=$* --headers="$(strip $(conformtest-headers-$*))" \
		  > $@ 2> $@.err; \
	$(evaluate-test)

linknamespace-libs-isoc = $(common-objpfx)libc.a $(common-objpfx)math/libm.a
linknamespace-libs-thr = $(linknamespace-libs-isoc) \
			 $(common-objpfx)rt/librt.a \
			 $(filter-out %_syms.a,$(static-thread-library))
linknamespace-libs-posix = $(linknamespace-libs-thr) \
			   $(common-objpfx)dlfcn/libdl.a
linknamespace-libs-xsi = $(linknamespace-libs-posix)
linknamespace-libs-ISO = $(linknamespace-libs-isoc)
linknamespace-libs-ISO99 = $(linknamespace-libs-isoc)
linknamespace-libs-ISO11 = $(linknamespace-libs-isoc) \
			   $(filter-out %_syms.a,$(static-thread-library))
linknamespace-libs-XPG4 = $(linknamespace-libs-isoc)
linknamespace-libs-XPG42 = $(linknamespace-libs-XPG4)
linknamespace-libs-POSIX = $(linknamespace-libs-thr)
linknamespace-libs-UNIX98 = $(linknamespace-libs-xsi)
linknamespace-libs-XOPEN2K = $(linknamespace-libs-xsi)
linknamespace-libs-POSIX2008 = $(linknamespace-libs-posix)
linknamespace-libs-XOPEN2K8 = $(linknamespace-libs-xsi)
linknamespace-libs = $(foreach std,$(conformtest-standards),\
				   $(linknamespace-libs-$(std)))

$(linknamespace-symlist-stdlibs-tests): $(objpfx)symlist-stdlibs-%: \
					$(linknamespace-libs)
	LC_ALL=C $(READELF) -W -s $(linknamespace-libs-$*) > $@; \
	$(evaluate-test)

$(linknamespace-header-tests): $(objpfx)%/linknamespace.out: \
			       linknamespace.py \
			       $(linknamespace-symlists-tests) \
			       $(linknamespace-symlist-stdlibs-tests)
	(set -e; std_hdr=$*; std=$${std_hdr%%/*}; hdr=$${std_hdr#*/}; \
	 mkdir -p $(@D); \
	 $(PYTHON) $< --cc='$(CC)' --flags='$(conformtest-cc-flags)' \
		   --standard=$$std --stdsyms=$(objpfx)symlist-$$std \
		   --header=$$hdr --libsyms=$(objpfx)symlist-stdlibs-$$std \
		   --readelf='$(READELF)' \
		   > $@ 2>&1); \
	$(evaluate-test)

# Pre-standard C feature no longer supported by GCC (obsoleted in
# newer POSIX standards).
test-xfail-XPG4/varargs.h/linknamespace = yes
test-xfail-XPG42/varargs.h/linknamespace = yes
test-xfail-UNIX98/varargs.h/linknamespace = yes

# Header not provided by glibc.
test-xfail-XPG42/ndbm.h/linknamespace = yes
test-xfail-UNIX98/ndbm.h/linknamespace = yes
test-xfail-XOPEN2K/ndbm.h/linknamespace = yes
test-xfail-XOPEN2K8/ndbm.h/linknamespace = yes

=== debug/Makefile ===
# Copyright (C) 1998-2025 Free Software Foundation, Inc.
# Copyright The GNU Toolchain Authors.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for debug portion of the library.
#
subdir	:= debug

include ../Makeconfig

headers	:= execinfo.h

# Note that ptsname_r_chk and getlogin_r are not here, but in
# login/Makefile instead.  If that subdir is omitted from the
# build, its _FORTIFY_SOURCE support will be too.
routines = \
  $(static-only-routines) \
  ____longjmp_chk \
  asprintf_chk \
  backtrace \
  backtracesyms \
  backtracesymsfd \
  chk_fail \
  confstr_chk \
  dprintf_chk \
  explicit_bzero_chk \
  fdelt_chk \
  fgets_chk \
  fgets_u_chk \
  fgetws_chk \
  fgetws_u_chk \
  fortify_fail \
  fprintf_chk \
  fread_chk \
  fread_u_chk \
  fwprintf_chk \
  getcwd_chk \
  getdomainname_chk \
  getgroups_chk \
  gethostname_chk \
  gets_chk \
  getwd_chk \
  longjmp_chk \
  mbsnrtowcs_chk \
  mbsrtowcs_chk \
  mbstowcs_chk \
  memcpy_chk \
  memmove_chk \
  mempcpy_chk \
  memset_chk \
  noophooks \
  obprintf_chk \
  poll_chk \
  ppoll_chk \
  pread64_chk \
  pread_chk \
  printf_chk \
  read_chk \
  readlink_chk \
  readlinkat_chk \
  readonly-area \
  realpath_chk \
  recv_chk \
  recvfrom_chk \
  snprintf_chk \
  sprintf_chk \
  stack_chk_fail \
  stpcpy_chk \
  stpncpy_chk \
  strcat_chk \
  strcpy_chk \
  strlcat_chk \
  strlcpy_chk \
  strncat_chk \
  strncpy_chk \
  swprintf_chk \
  ttyname_r_chk \
  vasprintf_chk \
  vdprintf_chk \
  vfprintf_chk \
  vfwprintf_chk \
  vobprintf_chk \
  vprintf_chk \
  vsnprintf_chk \
  vsprintf_chk \
  vswprintf_chk \
  vwprintf_chk \
  wcpcpy_chk \
  wcpncpy_chk \
  wcrtomb_chk \
  wcscat_chk \
  wcscpy_chk \
  wcslcat_chk \
  wcslcpy_chk \
  wcsncat_chk \
  wcsncpy_chk \
  wcsnrtombs_chk \
  wcsrtombs_chk \
  wcstombs_chk \
  wctomb_chk \
  wmemcpy_chk \
  wmemmove_chk \
  wmempcpy_chk \
  wmemset_chk \
  wprintf_chk \
  # routines
static-only-routines := stack_chk_fail_local

# Don't add stack_chk_fail_local.o to libc.a since __stack_chk_fail_local
# is an alias of __stack_chk_fail in stack_chk_fail.o.
elide-routines.o := stack_chk_fail_local

# Building the stack-protector failure routines with stack protection
# is not required since we have already failed a stack check and are
# exiting the process.  However, the local aliases which jump to the
# real routines should still be compiled with stack protection
# (stack_chk_fail_local.c), so that the statically linked parts of the
# library have the expected flags.

CFLAGS-stack_chk_fail.c += $(no-stack-protector)

CFLAGS-backtrace.c += -fno-omit-frame-pointer -funwind-tables
CFLAGS-sprintf_chk.c += $(libio-mtsafe)
CFLAGS-snprintf_chk.c += $(libio-mtsafe)
CFLAGS-vsprintf_chk.c += $(libio-mtsafe)
CFLAGS-vsnprintf_chk.c += $(libio-mtsafe)
CFLAGS-asprintf_chk.c += $(libio-mtsafe)
CFLAGS-vasprintf_chk.c += $(libio-mtsafe)
CFLAGS-obprintf_chk.c += $(libio-mtsafe)
CFLAGS-dprintf_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-vdprintf_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-printf_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-fprintf_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-vprintf_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-vfprintf_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-gets_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-fgets_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-fgets_u_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-fread_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-fread_u_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-swprintf_chk.c += $(libio-mtsafe)
CFLAGS-vswprintf_chk.c += $(libio-mtsafe)
CFLAGS-wprintf_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-fwprintf_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-vwprintf_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-vfwprintf_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-fgetws_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-fgetws_u_chk.c += $(libio-mtsafe) -fexceptions
CFLAGS-read_chk.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-pread_chk.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-pread64_chk.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-recv_chk.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-recvfrom_chk.c += -fexceptions -fasynchronous-unwind-tables

# Need to make sure the settings here override what configure might have
# set up for us, so keep the CFLAGS/CPPFLAGS split logical as the order is:
# <user CFLAGS> <test CFLAGS> <user CPPFLAGS> <test CPPFLAGS>
CFLAGS-tst-longjmp_chk.c += -fexceptions -fasynchronous-unwind-tables
CPPFLAGS-tst-longjmp_chk.c += $(no-fortify-source) -D_FORTIFY_SOURCE=1
CFLAGS-tst-longjmp_chk2.c += -fexceptions -fasynchronous-unwind-tables
CPPFLAGS-tst-longjmp_chk2.c += $(no-fortify-source) -D_FORTIFY_SOURCE=1
CFLAGS-tst-longjmp_chk3.c += -fexceptions -fasynchronous-unwind-tables
CPPFLAGS-tst-longjmp_chk3.c += $(no-fortify-source) -D_FORTIFY_SOURCE=1
CPPFLAGS-tst-realpath-chk.c += $(no-fortify-source) -D_FORTIFY_SOURCE=2
CPPFLAGS-tst-chk-cancel.c += $(no-fortify-source) -D_FORTIFY_SOURCE=2
CFLAGS-tst-sprintf-fortify-rdonly.c += $(no-fortify-source) -D_FORTIFY_SOURCE=2
CFLAGS-tst-fortify-syslog.c += $(no-fortify-source) -D_FORTIFY_SOURCE=2
CFLAGS-tst-fortify-wide.c += $(no-fortify-source) -D_FORTIFY_SOURCE=2

# _FORTIFY_SOURCE tests.
# Auto-generate tests for _FORTIFY_SOURCE for different levels, compilers and
# preprocessor conditions based on tst-fortify.c.
#
# To add a new test condition, define a cflags-$(cond) make variable to set
# CFLAGS for the file.

tests-all-chk = tst-fortify
tests-c-def-chk =
tests-cc-def-chk =
tests-c-time64-chk =
tests-cc-time64-chk =

CFLAGS-tst-fortify.c += -Wno-format -Wno-deprecated-declarations -Wno-error

# No additional flags for the default tests.
define cflags-default
endef

define cflags-lfs
CFLAGS-tst-fortify-$(1)-lfs-$(2)-$(3).$(1) += -D_FILE_OFFSET_BITS=64
endef

define cflags-nongnu
CFLAGS-tst-fortify-$(1)-nongnu-$(2)-$(3).$(1) += -D_LARGEFILE64_SOURCE=1
endef

src-chk-nongnu = \#undef _GNU_SOURCE

# We know these tests have problems with format strings, this is what
# we are testing.  Disable that warning.  They are also testing
# deprecated functions (notably gets) so disable that warning as well.
# And they also generate warnings from warning attributes, which
# cannot be disabled via pragmas, so require -Wno-error to be used.
define gen-chk-test
tests-$(1)-$(4)-chk += tst-fortify-$(1)-$(2)-$(3)-$(4)
CFLAGS-tst-fortify-$(1)-$(2)-$(3)-$(4).$(1) += $(no-fortify-source) -D_FORTIFY_SOURCE=$(3) \
					  -Wno-format \
					  -Wno-deprecated-declarations \
					  -Wno-error
$(eval $(call cflags-$(2),$(1),$(3),$(4)))
$(objpfx)tst-fortify-$(1)-$(2)-$(3)-$(4).$(1): tst-fortify.c Makefile
	( echo "/* Autogenerated from Makefile.  */"; \
	  echo "$(src-chk-$(2))"; \
	  echo "#include \"tst-fortify.c\"" ) > $$@.tmp
	mv $$@.tmp $$@
endef

chk-extensions = c cc
chk-types = default lfs nongnu
# 64 bit time_t implies LFS.
chk-types-time64 = default nongnu
chk-levels = 1 2 3

$(foreach e,$(chk-extensions), \
  $(foreach t,$(chk-types), \
    $(foreach l,$(chk-levels), \
      $(eval $(call gen-chk-test,$(e),$(t),$(l),def)))))

tests-all-chk += $(tests-c-def-chk) $(tests-cc-def-chk)

$(foreach e,$(chk-extensions), \
  $(foreach t,$(chk-types-time64), \
    $(foreach l,$(chk-levels), \
      $(eval $(call gen-chk-test,$(e),$(t),$(l),time64)))))

tests-all-time64-chk += $(tests-c-time64-chk) $(tests-cc-time64-chk)

define link-cc
LDLIBS-$(1) = -lstdc++
endef
$(foreach t,$(tests-cc-def-chk), $(eval $(call link-cc,$(t))))
$(foreach t,$(tests-cc-time64-chk), $(eval $(call link-cc,$(t))))

# backtrace_symbols only works if we link with -rdynamic.  backtrace
# requires unwind tables on most architectures.
CFLAGS-tst-backtrace2.c += -funwind-tables
CFLAGS-tst-backtrace3.c += -funwind-tables
CFLAGS-tst-backtrace4.c += -funwind-tables
CFLAGS-tst-backtrace5.c += -funwind-tables
CFLAGS-tst-backtrace6.c += -funwind-tables
LDFLAGS-tst-backtrace2 = -rdynamic
LDFLAGS-tst-backtrace3 = -rdynamic
LDFLAGS-tst-backtrace4 = -rdynamic
LDFLAGS-tst-backtrace5 = -rdynamic
LDFLAGS-tst-backtrace6 = -rdynamic

CFLAGS-tst-ssp-1.c += -fstack-protector-all

# Disable compiler optimizations around vsprintf (the function under test).
CFLAGS-tst-sprintf-fortify-unchecked.c = \
  -fno-builtin-vsprintf -fno-builtin-__vsprintf_chk

tests = \
  $(tests-all-chk) \
  backtrace-tst \
  test-stpcpy_chk \
  test-strcpy_chk \
  tst-backtrace2 \
  tst-backtrace3 \
  tst-backtrace4 \
  tst-backtrace5 \
  tst-backtrace6 \
  tst-fortify-wide \
  tst-longjmp_chk \
  tst-longjmp_chk2 \
  tst-longjmp_chk3 \
  tst-realpath-chk \
  tst-sprintf-fortify-rdonly \
  tst-sprintf-fortify-unchecked \
  # tests

tests-time64 += \
  $(tests-all-time64-chk) \
  # tests-time64

tests-container += \
  tst-fortify-syslog \
  # tests-container

ifeq ($(have-ssp),yes)
tests += tst-ssp-1
endif

ifeq ($(have-thread-library), yes)
tests += tst-chk-cancel
endif

ifeq (,$(CXX))
tests-unsupported = $(tests-cc-def-chk) $(tests-cc-time64-chk)
endif

extra-libs = libpcprofile
extra-libs-others = $(extra-libs)

libpcprofile-routines = pcprofile
libpcprofile-inhibit-o = $(filter-out .os,$(object-suffixes))

others = pcprofiledump
install-bin = pcprofiledump
install-bin-script = xtrace

generated += xtrace

include ../Rules

ifeq ($(run-built-tests),yes)
LOCALES := de_DE.UTF-8
include ../gen-locales.mk

define chk-gen-locales
$(objpfx)$(1).out: $(gen-locales)
endef
$(foreach t, $(tests-all-chk), $(eval $(call chk-gen-locales,$(t))))
$(foreach t, $(tests-all-time64-chk), $(eval $(call chk-gen-locales,$(t))))
endif

sLIBdir := $(shell echo $(slibdir) | sed 's,lib\(\|64\)$$,\\\\$$LIB,')

$(objpfx)pcprofiledump: $(objpfx)pcprofiledump.o

$(objpfx)xtrace: xtrace.sh
	rm -f $@.new
	sed -e 's|@VERSION@|$(version)|' -e 's|@SLIBDIR@|$(sLIBdir)|' \
	    -e 's|@BINDIR@|$(bindir)|' -e 's|@PKGVERSION@|$(PKGVERSION)|' \
	    -e 's|@REPORT_BUGS_TO@|$(REPORT_BUGS_TO)|' $^ > $@.new \
	&& rm -f $@ && mv $@.new $@ && chmod +x $@

$(objpfx)tst-chk-cancel: $(shared-thread-library)

=== hurd/Makefile ===
# Copyright (C) 1991-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

subdir := hurd

include ../Makeconfig

headers = \
  $(interface-headers) \
  hurd.h \
  hurd/fd.h \
  hurd/id.h \
  hurd/ioctl.h \
  hurd/lookup.h \
  hurd/port.h \
  hurd/resource.h \
  hurd/signal.h \
  hurd/sigpreempt.h \
  hurd/userlink.h \
  # headers

inline-headers = \
  hurd.h \
  hurd/fd.h \
  hurd/port.h \
  hurd/signal.h \
  hurd/userlink.h \
  # inline-headers

# The RPC interfaces go in a separate library.
interface-library := libhurduser
user-interfaces := \
  hurd/auth \
  hurd/crash \
  hurd/exec \
  hurd/exec_startup \
  hurd/fs \
  hurd/fsys \
  hurd/ifsock \
  hurd/interrupt \
  hurd/io \
  hurd/io_reply \
  hurd/io_request \
  hurd/login \
  hurd/msg \
  hurd/msg_reply \
  hurd/msg_request \
  hurd/password \
  hurd/pci \
  hurd/pfinet \
  hurd/process \
  hurd/process_request \
  hurd/socket \
  hurd/startup \
  hurd/term \
  hurd/tioctl \
  # user-interfaces

server-interfaces := \
  faultexc \
  hurd/msg \
  # server-interfaces

routines = \
  $(dtable) \
  $(inlines) \
  $(sig) \
  errno-loc \
  fchroot \
  fd-cleanup \
  fopenport \
  get-host \
  geteuids \
  getumask \
  hurdauth \
  hurdchdir \
  hurdexec \
  hurdfchdir \
  hurdid \
  hurdinit \
  hurdlock \
  hurdlookup \
  hurdmsg \
  hurdpid \
  hurdports \
  hurdprio \
  hurdrlimit \
  hurdselect \
  hurdsock \
  hurdstartup \
  lookup-at \
  lookup-retry \
  msgportdemux \
  path-lookup \
  pid2task \
  port-cleanup \
  ports-get \
  ports-set \
  privports \
  report-wait \
  set-host \
  setauth \
  seteuids \
  task2pid \
  vpprintf \
  xattr \
  # routines
sig = \
  catch-exc \
  catch-signal \
  exc2signal \
  hurd-raise \
  hurdfault \
  hurdkill \
  hurdsig \
  intr-msg \
  longjmp-ts \
  preempt-sig \
  siginfo \
  sigunwind \
  thread-cancel \
  thread-self \
  trampoline \
  # sig
dtable = \
  alloc-fd \
  ctty-input \
  ctty-output \
  dtable \
  fd-close \
  fd-read \
  fd-write \
  getdport \
  hurdioctl \
  intern-fd \
  new-fd \
  openport \
  port2fd \
  # dtable
inlines = $(inline-headers:%.h=%-inlines)

# XXX this is a temporary hack; see hurdmalloc.h
routines += hurdmalloc

# Binary compatibility for libc.so.0.2[GLIBC_2.0].
ifeq ($(build-shared),yes)
routines += compat-20
endif

shared-only-routines = compat-20

# For each of the $(inline-headers), generate a trivial source
# file that will #include it to define its inline functions as real functions.
$(inlines:%=$(objpfx)%.c): $(objpfx)%-inlines.c: %.h
	(h="`echo $(subst /,_,$*) | tr '[a-z]' '[A-Z]'`"; \
	 echo "#define _$${h}_H_EXTERN_INLINE /* Define real function.  */"; \
	 echo "#define _$${h}_H_HIDDEN_DEF    /* Declare hidden definition.  */"; \
	 echo '#include "$<"') > $@-new
	mv -f $@-new $@
generated += $(inlines:=.c)

# Avoid ssp before TLS is initialized.
CFLAGS-hurdstartup.o = $(no-stack-protector)
CFLAGS-RPC_exec_startup_get_info.o = $(no-stack-protector)

# Make it simpler to unwind over INTR_MSG_TRAP
CFLAGS-intr-msg.o = -fno-omit-frame-pointer
CFLAGS-intr-msg.os = -fno-omit-frame-pointer

# Make generated headers compatible with all support standards
migheaderpipe := | sed -e 's/\<ino64_t\>/__ino64_t/' -e 's/\<loff_t\>/__loff_t/'
include ../mach/Machrules
libhurduser-routines += RPC_gsync_wait_intr
include ../Rules

# intr-rpc.defs defines the INTR_INTERFACE macro to make the generated RPC
# stubs import <hurd/signal.h> and #define __mach_msg to
# _hurd_intr_rpc_mach_msg.
user-MIGFLAGS += -imacros intr-rpc.defs

# The special exc server for sigthread faults uses a special prefix.
MIGFLAGS-faultexc = -prefix _hurdsig_fault_

# We need this static dependency to get faultexc.h generated the first time.
$(objpfx)hurdfault.o $(objpfx)hurdfault.d: \
	$(objpfx)faultexc_server.h $(objpfx)faultexc_server.c

=== libio/Makefile ===
# Copyright (C) 1995-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Specific makefile for libio.
#
subdir	:= libio

include ../Makeconfig

headers	:= stdio.h \
	   bits/stdio.h bits/stdio2.h bits/stdio2-decl.h bits/stdio-ldbl.h \
	   bits/types/FILE.h bits/types/__FILE.h bits/types/struct_FILE.h \
	   bits/types/__fpos_t.h bits/types/__fpos64_t.h \
	   bits/types/cookie_io_functions_t.h

routines	:=							      \
	filedoalloc iofclose iofdopen iofflush iofgetpos iofgets iofopen      \
	iofopncook iofputs iofread iofsetpos ioftell wfiledoalloc	      \
	iofwrite iogetdelim iogetline iogets iopadn iopopen ioputs	      \
	ioseekoff ioseekpos iosetbuffer iosetvbuf ioungetc		      \
	iovsprintf iovsscanf						      \
	iofgetpos64 iofopen64 iofsetpos64				      \
	fputwc fputwc_u getwc getwc_u getwchar getwchar_u iofgetws iofgetws_u \
	iofputws iofputws_u iogetwline iowpadn ioungetwc putwc putwc_u	      \
	putwchar putwchar_u putchar putchar_u fwprintf swprintf vwprintf      \
	wprintf wscanf fwscanf vwscanf vswprintf iovswscanf swscanf wgenops   \
	wstrops wfileops iofwide fwide wmemstream			      \
									      \
	clearerr feof ferror fileno fputc freopen fseek getc getchar	      \
	memstream pclose putc putchar rewind setbuf setlinebuf vasprintf      \
	iovdprintf vscanf vsnprintf obprintf fcloseall fseeko ftello	      \
	freopen64 fseeko64 ftello64					      \
									      \
	__fbufsize __freading __fwriting __freadable __fwritable __flbf	      \
	__fpurge __fpending __fsetlocking				      \
									      \
	libc_fatal fmemopen oldfmemopen vtables

gen-as-const-headers += libio-macros.sym

# Exclude fortified routines from being built with _FORTIFY_SOURCE
routines_no_fortify += \
  fwprintf \
  iofgets \
  iofgets_u \
  iofgetws \
  iofgetws_u \
  swprintf \
  vasprintf \
  vsnprintf \
  vswprintf \
  vwprintf \
  wprintf \
  # routines_no_fortify

tests = \
  bug-fopena+ \
  bug-fseek \
  bug-ftell \
  bug-memstream1 \
  bug-mmap-fflush \
  bug-rewind \
  bug-rewind2 \
  bug-ungetc \
  bug-ungetc2 \
  bug-ungetc3 \
  bug-ungetc4 \
  bug-ungetwc1 \
  bug-ungetwc2 \
  bug-wfflush \
  bug-wmemstream1 \
  bug-wsetpos \
  test-fmemopen \
  test-fputs-unbuffered-full \
  test-fputws-unbuffered-full \
  tst-asprintf-null \
  tst-atime \
  tst-bz22415 \
  tst-bz24051 \
  tst-bz24153 \
  tst-bz28828 \
  tst-closeall \
  tst-eof \
  tst-ext \
  tst-ext2 \
  tst-fclose-unopened \
  tst-fclose-unopened2 \
  tst-fdopen-seek-failure \
  tst-fgetc-after-eof \
  tst-fgetwc \
  tst-fgetws \
  tst-fopenloc2 \
  tst-fputws \
  tst-freopen \
  tst-fseek \
  tst-ftell-active-handler \
  tst-ftell-append \
  tst-ftell-partial-wide \
  tst-fwrite-error \
  tst-getdelim \
  tst-memstream1 \
  tst-memstream2 \
  tst-memstream3 \
  tst-memstream4 \
  tst-mmap-eofsync \
  tst-mmap-fflushsync \
  tst-mmap-offend \
  tst-mmap-setvbuf \
  tst-mmap2-eofsync \
  tst-popen-fork \
  tst-popen1 \
  tst-setvbuf1 \
  tst-sprintf-chk-ub \
  tst-sprintf-ub \
  tst-sscanf \
  tst-swscanf \
  tst-ungetwc1 \
  tst-ungetwc2 \
  tst-wfile-sync \
  tst-widetext \
  tst-wmemstream1 \
  tst-wmemstream2 \
  tst-wmemstream3 \
  tst-wmemstream4 \
  tst-wmemstream5 \
  tst_getwc \
  tst_putwc \
  tst_swprintf \
  tst_swscanf \
  tst_wprintf \
  tst_wprintf2 \
  tst_wscanf \
  # tests

$(objpfx)tst-popen-fork: $(shared-thread-library)

tests-internal = tst-vtables tst-vtables-interposed

ifeq (yes,$(build-shared))
# Add test-fopenloc only if shared library is enabled since it depends on
# shared localedata objects.
tests += tst-fopenloc
# Add tst-bz24228 only if shared library is enabled since it can never meet its
# objective with static linking because the relevant code just is not there.
tests += tst-bz24228
endif
test-srcs = test-freopen

ifeq ($(build-shared),yes)
routines += oldiofopen oldiofdopen oldiofclose oldiopopen oldpclose \
	    oldtmpfile oldiofgetpos oldiofgetpos64 oldiofsetpos	    \
	    oldiofsetpos64
endif

ifeq (yes,$(libc-reentrant))
routines += clearerr_u feof_u ferror_u fputc_u getc_u getchar_u		      \
	    iofflush_u putc_u putchar_u peekc iofread_u iofwrite_u iofgets_u  \
	    iofputs_u
endif

CPPFLAGS += $(libio-mtsafe)

# Support for exception handling.
CFLAGS-fileops.c += -fexceptions
CFLAGS-fputc.c += -fexceptions
CFLAGS-fputwc.c += -fexceptions
CFLAGS-freopen64.c += -fexceptions
CFLAGS-freopen.c += -fexceptions
CFLAGS-fseek.c += -fexceptions
CFLAGS-fseeko64.c += -fexceptions
CFLAGS-fseeko.c += -fexceptions
CFLAGS-ftello64.c += -fexceptions
CFLAGS-ftello.c += -fexceptions
CFLAGS-fwide.c += -fexceptions
CFLAGS-genops.c += -fexceptions
CFLAGS-getc.c += -fexceptions
CFLAGS-getchar.c += -fexceptions
CFLAGS-getwc.c += -fexceptions
CFLAGS-getwchar.c += -fexceptions
CFLAGS-iofclose.c += -fexceptions
CFLAGS-iofflush.c += -fexceptions $(config-cflags-wno-ignored-attributes)
CFLAGS-iofgetpos64.c += -fexceptions
CFLAGS-iofgetpos.c += -fexceptions
CFLAGS-iofgets.c += -fexceptions
CFLAGS-iofgetws.c += -fexceptions
CFLAGS-iofputs.c += -fexceptions $(config-cflags-wno-ignored-attributes)
CFLAGS-iofputws.c += -fexceptions
CFLAGS-iofread.c += -fexceptions
CFLAGS-iofsetpos64.c += -fexceptions
CFLAGS-iofsetpos.c += -fexceptions
CFLAGS-ioftell.c += -fexceptions
CFLAGS-iofwrite.c += -fexceptions $(config-cflags-wno-ignored-attributes)
CFLAGS-iogetdelim.c += -fexceptions
CFLAGS-iogetline.c += -fexceptions
CFLAGS-iogets.c += -fexceptions
CFLAGS-iogetwline.c += -fexceptions
CFLAGS-ioputs.c += -fexceptions
CFLAGS-ioseekoff.c += -fexceptions
CFLAGS-ioseekpos.c += -fexceptions
CFLAGS-iosetbuffer.c += -fexceptions
CFLAGS-iosetvbuf.c += -fexceptions
CFLAGS-ioungetc.c += -fexceptions
CFLAGS-ioungetwc.c += -fexceptions
CFLAGS-oldfileops.c += -fexceptions
CFLAGS-oldiofclose.c += -fexceptions
CFLAGS-oldiofgetpos64.c += -fexceptions
CFLAGS-oldiofgetpos.c += -fexceptions
CFLAGS-oldiofsetpos64.c += -fexceptions
CFLAGS-oldiofsetpos.c += -fexceptions
CFLAGS-peekc.c += -fexceptions
CFLAGS-putc.c += -fexceptions
CFLAGS-putchar.c += -fexceptions
CFLAGS-putwc.c += -fexceptions
CFLAGS-putwchar.c += -fexceptions
CFLAGS-rewind.c += -fexceptions
CFLAGS-wfileops.c += -fexceptions
CFLAGS-wgenops.c += -fexceptions
CFLAGS-oldiofopen.c += -fexceptions
CFLAGS-iofopen.c += -fexceptions
CFLAGS-iofopen64.c += -fexceptions
CFLAGS-oldtmpfile.c += -fexceptions
CFLAGS-fileno.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-feof_u.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-ferror_u.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-getc_u.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-iofflush_u.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-putc_u.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-iofgets_u.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-iofputs_u.c += $(config-cflags-wno-ignored-attributes)
# XXX Do we need filedoalloc and wfiledoalloc?  Others?

# Prevent fortification as these are built with -O0
CFLAGS-tst-bz24051.c += $(no-fortify-source)
CFLAGS-tst-bz24153.c += $(no-fortify-source)

CFLAGS-tst_putwc.c += -DOBJPFX=\"$(objpfx)\"

# These test cases intentionally use overlapping arguments
CFLAGS-tst-sprintf-ub.c += $(test-config-cflags-wno-restrict) \
			   $(no-fortify-source)
CFLAGS-tst-sprintf-chk-ub.c += $(test-config-cflags-wno-restrict) \
			       $(no-fortify-source)

LDFLAGS-tst-bz24228 = -Wl,--version-script=tst-bz24228.map

tst_wprintf2-ARGS = "Some Text"

tst-fclose-unopened2-ENV = \
  MALLOC_TRACE=$(objpfx)tst-fclose-unopened2.mtrace \
  LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
test-fmemopen-ENV = MALLOC_TRACE=$(objpfx)test-fmemopen.mtrace \
		    LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
tst-fdopen-seek-failure-ENV = \
  MALLOC_TRACE=$(objpfx)tst-fdopen-seek-failure.mtrace \
  LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
tst-fopenloc-ENV = MALLOC_TRACE=$(objpfx)tst-fopenloc.mtrace \
		   LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
tst-bz22415-ENV = MALLOC_TRACE=$(objpfx)tst-bz22415.mtrace \
		  LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
tst-bz24228-ENV = MALLOC_TRACE=$(objpfx)tst-bz24228.mtrace \
		  LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so

aux	:= fileops genops stdfiles stdio strops

ifeq ($(run-built-tests),yes)
ifeq ($(build-shared),yes)
ifneq ($(PERL),no)
generated += \
  test-fmemopen.check \
  test-fmemopen.mtrace \
  tst-bz22415.check \
  tst-bz22415.mtrace \
  tst-bz24228.check \
  tst-bz24228.mtrace \
  tst-fclose-unopened2.check \
  tst-fclose-unopened2.mtrace \
  tst-fdopen-seek-failure.check \
  tst-fdopen-seek-failure.mtrace \
  tst-fopenloc.check \
  tst-fopenloc.mtrace \
  # generated
endif
endif
endif

ifeq ($(build-shared),yes)
aux	+= oldfileops oldstdfiles
tests += \
  tst-fopen-compat \
  tst-stderr-compat \
# tests
tests-2.0 += \
  tst-fopen-compat \
  tst-stderr-compat \
# tests-2.0

tst-fopen-compat-ARGS = tst-fopen-compat.c
# Disable PIE to trigger copy relocation.
CFLAGS-tst-fopen-compat.c += -fno-pie
tst-fopen-compat-no-pie = yes
endif

shared-only-routines = oldiofopen oldiofdopen oldiofclose oldfileops	\
		       oldstdfiles oldiopopen oldpclose oldtmpfile	\
		       oldiofgetpos oldiofgetpos64 oldiofsetpos		\
		       oldiofsetpos64

ifeq ($(run-built-tests),yes)
tests-special += \
  $(objpfx)test-freopen.out \
  # tests-special
ifeq (yes,$(build-shared))
# Run tst-fopenloc-cmp.out and tst-openloc-mem.out only if shared
# library is enabled since they depend on tst-fopenloc.out.
tests-special += $(objpfx)tst-fopenloc-cmp.out
ifeq ($(build-shared),yes)
ifneq ($(PERL),no)
tests-special += \
  $(objpfx)test-fmemopen-mem.out \
  $(objpfx)tst-bz22415-mem.out \
  $(objpfx)tst-bz24228-mem.out \
  $(objpfx)tst-fclose-unopened2-mem.out \
  $(objpfx)tst-fdopen-seek-failure-mem.out \
  $(objpfx)tst-fopenloc-mem.out \
  # tests-special
endif
endif
endif

tests += \
  tst-cleanup-default \
  tst-cleanup-default-static \
  # tests
tests-static += tst-cleanup-default-static
tests-special += $(objpfx)tst-cleanup-default-cmp.out $(objpfx)tst-cleanup-default-static-cmp.out
LDFLAGS-tst-cleanup-default = -Wl,--gc-sections
LDFLAGS-tst-cleanup-default-static = -Wl,--gc-sections

ifeq ($(have-gnu-retain)$(have-z-start-stop-gc),yesyes)
tests += \
  tst-cleanup-nostart-stop-gc \
  tst-cleanup-nostart-stop-gc-static \
  tst-cleanup-start-stop-gc \
  tst-cleanup-start-stop-gc-static \
  # tests
tests-static += \
  tst-cleanup-nostart-stop-gc-static \
  tst-cleanup-start-stop-gc-static \
  # tests-static
tests-special += $(objpfx)tst-cleanup-start-stop-gc-cmp.out \
		$(objpfx)tst-cleanup-start-stop-gc-static-cmp.out \
		$(objpfx)tst-cleanup-nostart-stop-gc-cmp.out \
		$(objpfx)tst-cleanup-nostart-stop-gc-static-cmp.out
LDFLAGS-tst-cleanup-start-stop-gc := -Wl,--gc-sections,-z,start-stop-gc
LDFLAGS-tst-cleanup-start-stop-gc-static := -Wl,--gc-sections,-z,start-stop-gc
LDFLAGS-tst-cleanup-nostart-stop-gc := -Wl,--gc-sections,-z,nostart-stop-gc
LDFLAGS-tst-cleanup-nostart-stop-gc-static := -Wl,--gc-sections,-z,nostart-stop-gc
endif
endif

include ../Rules

ifeq ($(run-built-tests),yes)
LOCALES := de_DE.ISO-8859-1 de_DE.UTF-8 en_US.ISO-8859-1 en_US.UTF-8 \
	   ja_JP.EUC-JP ja_JP.UTF-8
include ../gen-locales.mk

$(objpfx)bug-ftell.out: $(gen-locales)
$(objpfx)bug-ungetwc1.out: $(gen-locales)

=== login/Makefile ===
# Copyright (C) 1996-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for login portion of the library.
#

subdir	:= login

include ../Makeconfig

headers := \
  bits/utmp.h \
  lastlog.h \
  pty.h \
  utmp.h \
  # headers

routines := \
  forkpty \
  getlogin \
  getlogin_r \
  getlogin_r_chk \
  getpt \
  getutent \
  getutent_r \
  getutid \
  getutid_r \
  getutline \
  getutline_r \
  grantpt \
  login \
  login_tty \
  logout \
  logwtmp \
  openpty \
  ptsname \
  ptsname_r_chk \
  setlogin \
  unlockpt \
  updwtmp \
  utmp_file \
  utmpname \
  # routines

CFLAGS-grantpt.c += -DLIBEXECDIR='"$(libexecdir)"'

others = utmpdump

ifeq (yes,$(build-pt-chown))
others += \
  pt_chown \
  # others
others-pie = \
  pt_chown \
  # others-pie
install-others-programs = $(inst_libexecdir)/pt_chown
endif

subdir-dirs = programs
vpath %.c programs

tests := \
  tst-getlogin \
  tst-grantpt \
  tst-ptsname \
  tst-pututxline-cache \
  tst-pututxline-lockfail \
  tst-updwtmpx \
  tst-utmp \
  tst-utmp-size \
  tst-utmp-size-64 \
  tst-utmp-unsigned \
  tst-utmp-unsigned-64 \
  tst-utmpx \
  # tests

CFLAGS-tst-utmp-size-64.c += -D_FILE_OFFSET_BITS=64 -D_TIME_BITS=64
CFLAGS-tst-utmp-unsigned-64.c += -D_FILE_OFFSET_BITS=64 -D_TIME_BITS=64

# Empty compatibility library for old binaries.
extra-libs      := libutil
extra-libs-others := $(extra-libs)
ifeq ($(have-GLIBC_2.33),yes)
libutil-routines := libutil-compat
libutil-shared-only-routines := libutil-compat

# Pretend that libutil.so is a linker script, so that the symbolic
# link is not installed.
install-lib-ldscripts = libutil.so
$(inst_libdir)/libutil.so:
else  # not $(have-GLIBC_2.33)
libutil-inhibit-o = $(filter-out .o,$(object-suffixes))
endif # $(have-GLIBC_2.33)

include ../Rules

CFLAGS-getpt.c += -fexceptions
CFLAGS-getlogin_r.c += $(config-cflags-wno-ignored-attributes)

# Exclude fortified routines from being built with _FORTIFY_SOURCE
routines_no_fortify += \
  getlogin_r \
  ptsname_r \
  # routines_no_fortify

ifeq (yesyes,$(have-fpie)$(build-shared))
pt_chown-cflags += $(pie-ccflag)
endif
ifeq (yes,$(have-libcap))
libcap = -lcap
endif
CFLAGS-pt_chown.c += $(pt_chown-cflags)
LDLIBS-pt_chown = $(libcap)
ifeq (yesyes,$(have-fpie)$(build-shared))
LDFLAGS-pt_chown = -Wl,-z,now
endif

# pt_chown needs to be setuid root.
$(inst_libexecdir)/pt_chown: $(objpfx)pt_chown $(+force)
	$(make-target-directory)
	-$(INSTALL_PROGRAM) -m 4755 -o root $< $@

$(objpfx)tst-pututxline-lockfail: $(shared-thread-library)
$(objpfx)tst-pututxline-cache: $(shared-thread-library)

=== mach/Makefile ===
# Copyright (C) 1991-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

subdir := mach

include ../Makeconfig

headers = mach_init.h mach.h mach_error.h mach-shortcuts.h mach/mach_traps.h \
	  $(interface-headers) mach/mach.h mach/mig_support.h mach/error.h \
	  $(lock-headers) machine-sp.h bits/mach/param.h
lock = spin-solid spin-lock mutex-init mutex-solid
lock-headers = lock-intern.h spin-lock.h
routines = $(mach-syscalls) $(mach-shortcuts) \
	   mach_init mig_strncpy mig_strlen mig_memcpy msg \
	   mig-alloc mig-dealloc mig-reply \
	   msg-destroy msgserver \
	   mach_error errstring error_compat errsystems \
	   devstream setup-thread $(lock)

# The RPC interfaces go in a separate library.
interface-library := libmachuser

# We produce mach_interface.h from mach.defs because there is already a
# <mach/mach.h> that is not the interface header (thanks CMU).
mach-interface-list := $(patsubst mach,mach_interface,$(mach-interface-list))
mach/mach_interface.defs = mach/mach.defs

# Similarly for memory_object_user vs. memory_object
mach-interface-list := $(patsubst memory_object,memory_object_user,\
				  $(mach-interface-list))
mach/memory_object_user.defs = mach/memory_object.defs

user-interfaces := $(addprefix mach/,$(mach-interface-list)	\
			       	     mach_port mach_host exc	\
		    )\
		   $(addprefix device/,device device_request)

server-interfaces := mach/exc

# Clear any environment	value.
generated =

# Avoid ssp before TLS is initialized.
CFLAGS-mach_init.o = $(no-stack-protector)
CFLAGS-RPC_vm_statistics.o = $(no-stack-protector)
CFLAGS-RPC_vm_map.o = $(no-stack-protector)
CFLAGS-RPC_vm_protect.o = $(no-stack-protector)
CFLAGS-RPC_i386_set_gdt.o = $(no-stack-protector)
CFLAGS-RPC_i386_set_ldt.o = $(no-stack-protector)
CFLAGS-RPC_task_get_special_port.o = $(no-stack-protector)
CFLAGS-RPC_thread_set_state.o = $(no-stack-protector)

# Translate GNU names for CPUs into the names used in Mach header files.
mach-machine = $(patsubst powerpc,ppc,$(base-machine))

# Define mach-syscalls and sysno-*.
ifndef inhibit_mach_syscalls
-include $(objpfx)mach-syscalls.mk
endif
$(objpfx)mach-syscalls.mk: syscalls.awk Makefile libc-modules.h
# Go kludges!!!
	$(make-target-directory)
# We must use $(CFLAGS) to get -O flags that affect #if's in header files.
	echo '#include <mach/syscall_sw.h>' | \
	$(CC) $(CFLAGS) $(CPPFLAGS) -E -MD -MP -MF $@-dep -MT $@ \
	      -x c-header - \
	      -D_MACH_`echo $(mach-machine) | tr a-z A-Z`_SYSCALL_SW_H_=1 | \
	sed -n -e 's/^kernel_trap(\(.*\),\([-0-9]*\),\([0-9]*\))$$/\1 \2 \3/p'\
	| $(AWK) -f $< > $@-new
ifneq (,$(objpfx))
	sed $(sed-remove-objpfx) $@-dep >> $@-new
else
	cat $@-dep >> $@-new
endif
	rm -f $@-dep
	mv -f $@-new $@
generated += mach-syscalls.mk

ifndef mach-syscalls
# We cannot make the deps properly until we know how to make the system
# call functions, and for that we must know what they all are.
no_deps=t
else
$(mach-syscalls:%=$(objpfx)%.S): $(objpfx)%.S: $(objpfx)mach-syscalls.mk
	(echo '#include <sysdep.h>'; \
	 echo 'kernel_trap (__$*,$(sysno-$*),$(nargs-$*))'; \
	 echo 'weak_alias (__$*, $*)'; \
	 echo 'libc_hidden_def (__$*)') > $@-new
	 mv -f $@-new $@
generated += $(mach-syscalls:=.S)
endif	# mach-syscalls

# These syscalls that look like RPCs actually have no RPC equivalents.
mach-shortcuts := $(filter-out device_writev_request \
			       device_read_overwrite_request \
			       device_read_overwrite \
			       vm_read_overwrite \
			       thread_switch \
			       ,\
		  $(patsubst syscall_%,%,$(filter syscall_%,$(mach-syscalls))))

ifndef mach-shortcuts
# Forget about mach_interface.defs for this run.  On the next run,
# $(mach-shortcuts) will be set, and that will change how
# mach_interface.defs is processed: it will get the -D flags below.
user-interfaces := $(filter-out $(mach-interface-list:%=mach/%) \
				mach/mach_port mach/mach_host mach/mach4 mach/gnumach \
				device/device_request,\
				$(user-interfaces))
endif

# For some reason, the calls in this file are `protected' by an ifdef.
MIGFLAGS-mach/mach4 = -DMACH_PCSAMPLE
MIGFLAGS-device/device = -DDEVICE_ENABLE_DEVICE_OPEN_NEW

# Make the MiG stubs for $(mach-shortcuts) be CALL_rpc.
migdefines += $(foreach call,$(mach-shortcuts),-D$(call)=$(call)_rpc)
$(mach-interface-list:%=mach/%.uh) \
  mach/mach_host.uh mach/mach_port.uh: $(objpfx)mach-syscalls.mk

ifdef mach-shortcuts
$(mach-shortcuts:%=$(objpfx)%.c): $(objpfx)%.c: shortcut.awk \
						$(objpfx)RPC_%_rpc.c
	$(AWK)	-v alias=$* -v call=__$* -v rpc=__$*_rpc \
		-v syscall=__syscall_$* -f $^ > $@-new
	mv -f $@-new $@
generated += $(mach-shortcuts:%=%.c)
endif	# mach-shortcuts

# Generate mach-shortcuts.h, which will contain the prototypes for the
# shortcutted kernel RPC functions.
$(objpfx)mach-shortcuts.h: $(mach-interface-list:%=$(objpfx)mach/%.h) \
			   $(objpfx)mach/mach_host.h \
			   $(objpfx)mach/mach_port.h
# The first line gets us one paragraph per line, with @s separating real lines.
# The second line selects paragraphs for the shortcutted functions.
# The third line removes `_rpc' from the names and reconstitutes the lines.
	( echo "#include <mach/mach_types.h>" ; \
	  echo "#include <mach/message.h>" ; \
	  echo ; \
	  cat $^ | tr \\012 @ | sed s/@@/@%/g | tr % \\012 \
	  | grep '^/\* Routine [a-z0-9_]*_rpc \*/' \
	  | sed 's/_rpc//g' | tr @ \\012 ) > $@-new
	mv -f $@-new $@
generated += mach-shortcuts.h

before-compile += $(objpfx)mach-shortcuts.h

include Machrules
include ../Rules


# A gcc bug prevents the generated file from working properly,
# so we have one in the distribution for the time being.
generated += errsystems.c
$(objpfx)errsystems.c: errsystems.awk err_*.sub \
		       $(wildcard $(addsuffix /err_*.sub,$(+sysdep_dirs)))
	$(AWK) -v subsys='$(filter-out $<,$^)' -f $^ > $@.n
	mv -f $@.n $@


# Convenient target to update all the generated source files.
.PHONY: generated
generated: $(addprefix $(common-objpfx),$(common-generated)) \
	   $(addprefix $(objpfx),$(generated))

.PHONY: mach-before-compile
mach-before-compile: $(mach-before-compile)

=== mathvec/Makefile ===
# Copyright (C) 2014-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

# Makefile for the vector math library.

subdir		:= mathvec

include ../Makeconfig

ifeq ($(build-mathvec),yes)
extra-libs	:= libmvec
extra-libs-others = $(extra-libs)

libmvec-routines = $(strip $(libmvec-support))

$(objpfx)libmvec.so: $(libm)
endif

# Rules for the test suite are in math directory.

include ../Rules

=== misc/Makefile ===
# Copyright (C) 1991-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for misc portion of the library.
#

subdir	:= misc

include ../Makeconfig

headers := \
  a.out.h \
  ar.h \
  bits/err-ldbl.h \
  bits/error-ldbl.h \
  bits/error.h \
  bits/hwcap.h \
  bits/ioctl-types.h \
  bits/ioctls.h \
  bits/mman.h \
  bits/param.h \
  bits/select-decl.h \
  bits/select.h \
  bits/select2.h \
  bits/stab.def \
  bits/syslog-decl.h \
  bits/syslog-ldbl.h \
  bits/syslog-path.h \
  bits/syslog.h \
  bits/sysmacros.h \
  bits/types/struct_iovec.h \
  bits/uio-ext.h \
  bits/uio_lim.h \
  err.h \
  error.h \
  fstab.h \
  libgen.h \
  mntent.h \
  paths.h \
  regexp.h \
  search.h \
  sgtty.h \
  stab.h \
  sys/auxv.h \
  sys/cdefs.h \
  sys/dir.h \
  sys/file.h \
  sys/ioctl.h \
  sys/mman.h \
  sys/param.h \
  sys/ptrace.h \
  sys/queue.h \
  sys/reboot.h \
  sys/select.h \
  sys/single_threaded.h \
  sys/swap.h \
  sys/syscall.h \
  sys/sysinfo.h \
  sys/syslog.h \
  sys/sysmacros.h \
  sys/uio.h \
  sys/xattr.h \
  syscall.h \
  sysexits.h \
  syslog.h \
  ttyent.h \
  # headers

routines := \
  acct \
  allocate_once \
  atomic_wide_counter \
  brk \
  chflags \
  chroot \
  daemon \
  dirname \
  efgcvt \
  efgcvt_r \
  err \
  error \
  fchflags \
  fd_to_filename \
  fdatasync \
  fgetxattr \
  flistxattr \
  fremovexattr \
  fsetxattr \
  fstab \
  fsync \
  ftruncate \
  ftruncate64 \
  futimes \
  futimesat \
  getauxval \
  getclktck \
  getdomain \
  getdtsz \
  gethostid \
  gethostname \
  getloadavg \
  getpagesize \
  getpass \
  getsysstats \
  getttyent \
  getusershell \
  getxattr \
  gtty \
  hsearch \
  hsearch_r \
  ifunc-impl-list \
  insremque \
  ioctl \
  lgetxattr \
  listxattr \
  llistxattr \
  lremovexattr \
  lsearch \
  lsetxattr \
  lutimes \
  madvise \
  makedev \
  mincore \
  mkdtemp \
  mkostemp \
  mkostemp64 \
  mkostemps \
  mkostemps64 \
  mkstemp \
  mkstemp64 \
  mkstemps \
  mkstemps64 \
  mktemp \
  mlock \
  mlockall \
  mmap \
  mmap64 \
  mntent \
  mntent_r \
  mprotect \
  msync \
  munlock \
  munlockall \
  munmap \
  preadv \
  preadv2 \
  preadv64 \
  preadv64v2 \
  pselect \
  ptrace \
  pwritev \
  pwritev2 \
  pwritev64 \
  pwritev64v2 \
  qefgcvt \
  qefgcvt_r \
  readv \
  reboot \
  regexp \
  remap_file_pages \
  removexattr \
  revoke \
  sbrk \
  select \
  setdomain \
  setegid \
  seteuid \
  sethostid \
  sethostname \
  setregid \
  setreuid \
  setxattr \
  single_threaded \
  sstk \
  stty \
  swapoff \
  swapon \
  sync \
  syncfs \
  syscall \
  syslog \
  truncate \
  truncate64 \
  tsearch \
  ttyslot \
  ualarm \
  unwind-link \
  usleep \
  ustat \
  utimes \
  vhangup \
  writev \
  # routines

# Exclude fortified routines from being built with _FORTIFY_SOURCE
routines_no_fortify += \
  getdomain \
  gethostname \
  syslog \
  # routines_no_fortify

ifeq ($(run-built-tests),yes)
ifeq (yes,$(build-shared))
ifneq ($(PERL),no)
generated += \
  tst-allocate_once-mem.out \
  tst-allocate_once.mtrace \
  tst-error1-mem.out \
  tst-error1.mtrace \
  # generated
endif
endif
endif

aux := init-misc
install-lib := libg.a

gpl2lgpl := \
  error.c \
  error.h \
  # gpl2lgpl

tests := \
  bug-hsearch1 \
  bug18240 \
  tst-dbl-efgcvt \
  tst-dirname \
  tst-empty \
  tst-error1 \
  tst-fdset \
  tst-hsearch \
  tst-insremque \
  tst-ioctl \
  tst-ldbl-efgcvt \
  tst-ldbl-error \
  tst-ldbl-errorfptr \
  tst-ldbl-warn \
  tst-makedev \
  tst-mntent \
  tst-mntent-autofs \
  tst-mntent-blank-corrupt \
  tst-mntent-blank-passno \
  tst-mntent-escape \
  tst-mntent2 \
  tst-mremap1 \
  tst-mremap2 \
  tst-preadvwritev \
  tst-preadvwritev2 \
  tst-preadvwritev64 \
  tst-preadvwritev64v2 \
  tst-pselect \
  tst-select \
  tst-syscalls \
  tst-tsearch \
  tst-warn-wide \
  # tests

tests-time64 := \
  tst-ioctl-time64 \
  tst-pselect-time64 \
  tst-select-time64 \
  # tests-time64

# Tests which need libdl.
ifeq (yes,$(build-shared))
tests += tst-gethostid
endif

tests-internal := \
  tst-allocate_once \
  tst-atomic \
  tst-atomic-long \
  # tests-internal
tests-static := tst-empty

# Test for the internal, non-exported __fd_to_filename function.
tests-internal += tst-fd_to_filename
tests-static += tst-fd_to_filename

# Tests with long run times.
xtests += \
  tst-mkstemp-fuse \
  tst-mkstemp-fuse-parallel \
  # xtests

ifeq ($(run-built-tests),yes)
ifeq (yes,$(build-shared))
ifneq ($(PERL),no)
tests-special += \
  $(objpfx)tst-allocate_once-mem.out \
  $(objpfx)tst-error1-mem.out \
  # tests-special
endif
endif
endif

tests-container := \
  tst-syslog \
  tst-syslog-long-progname \
  # tests-container

CFLAGS-select.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-tsearch.c += $(uses-callbacks)
CFLAGS-lsearch.c += $(uses-callbacks)
CFLAGS-pselect.c += -fexceptions
CFLAGS-readv.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-writev.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-preadv.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-preadv64.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-pwritev.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-pwritev64.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-preadv2.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-preadv64v2.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-pwritev2.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-pwritev64v2.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-usleep.c += -fexceptions
CFLAGS-syslog.c += -fexceptions
CFLAGS-error.c += -fexceptions
CFLAGS-getpass.c += -fexceptions
CFLAGS-mkstemp.c += -fexceptions
CFLAGS-mkstemp64.c += -fexceptions
CFLAGS-getsysstats.c += -fexceptions
CFLAGS-getusershell.c += -fexceptions
CFLAGS-err.c += -fexceptions
CFLAGS-tst-tsearch.c += $(stack-align-test-flags)
CFLAGS-msync.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-fdatasync.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-fsync.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-makedev.c += $(config-cflags-wno-ignored-attributes)
CFLAGS-mmap64.c += $(config-cflags-wno-ignored-attributes)

# Called during static library initialization, so turn stack-protection
# off for non-shared builds.
CFLAGS-sbrk.o = $(no-stack-protector)
CFLAGS-sbrk.op = $(no-stack-protector)
CFLAGS-brk.o = $(no-stack-protector)
CFLAGS-brk.op = $(no-stack-protector)
CFLAGS-mmap.o = $(no-stack-protector)
CFLAGS-mmap.op = $(no-stack-protector)
CFLAGS-mmap64.o = $(no-stack-protector)
CFLAGS-mmap64.op = $(no-stack-protector)

include ../Rules

$(objpfx)libg.a: $(dep-dummy-lib); $(make-dummy-lib)

$(objpfx)tst-tsearch: $(libm)

tst-error1-ENV = MALLOC_TRACE=$(objpfx)tst-error1.mtrace \
		 LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
tst-error1-ARGS = $(objpfx)tst-error1.out
$(objpfx)tst-error1-mem.out: $(objpfx)tst-error1.out
	$(common-objpfx)malloc/mtrace $(objpfx)tst-error1.mtrace > $@; \
	$(evaluate-test)

tst-allocate_once-ENV = MALLOC_TRACE=$(objpfx)tst-allocate_once.mtrace \
			LD_PRELOAD=$(common-objpfx)/malloc/libc_malloc_debug.so
$(objpfx)tst-allocate_once-mem.out: $(objpfx)tst-allocate_once.out
	$(common-objpfx)malloc/mtrace $(objpfx)tst-allocate_once.mtrace > $@; \
	$(evaluate-test)

tst-syslog-long-progname-ENV = GLIBC_TUNABLES=glibc.malloc.check=3 \
			       LD_PRELOAD=libc_malloc_debug.so.0

$(objpfx)tst-select: $(librt)
$(objpfx)tst-select-time64: $(librt)
$(objpfx)tst-pselect: $(librt)
$(objpfx)tst-pselect-time64: $(librt)
$(objpfx)tst-mkstemp-fuse-parallel: $(shared-thread-library)

=== nscd/Makefile ===
# Copyright (C) 1998-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for nscd portion of the library.
#
subdir	:= nscd

include ../Makeconfig

ifneq ($(use-nscd),no)
routines := nscd_getpw_r nscd_getgr_r nscd_gethst_r nscd_getai \
	    nscd_initgroups nscd_getserv_r nscd_netgroup
aux	:= nscd_helper
endif

# To find xmalloc.c
vpath %.c ../locale/programs

nscd-modules := nscd connections pwdcache getpwnam_r getpwuid_r grpcache \
		getgrnam_r getgrgid_r hstcache gethstbyad_r gethstbynm3_r \
		getsrvbynm_r getsrvbypt_r servicescache \
		dbg_log nscd_conf nscd_stat cache mem nscd_setup_thread \
		xmalloc xstrdup aicache initgrcache res_hconf \
		netgroupcache cachedumper

ifeq ($(build-nscd)$(have-thread-library),yesyes)

others += nscd
others-pie += nscd
install-sbin := nscd

extra-objs = $(nscd-modules:=.o)

endif

all-nscd-modules := $(nscd-modules) selinux
ifeq (yes,$(have-selinux))
ifeq (yes,$(have-libaudit))
libaudit = -laudit
ifeq (yes,$(have-libcap))
libcap = -lcap
endif
endif

nscd-modules += selinux
selinux-LIBS := -lselinux $(libaudit) $(libcap)

# The configure.ac check for libselinux and its headers did not use
# $SYSINCLUDES.  The directory specified by --with-headers usually
# contains only the basic kernel interface headers, not something like
# libselinux.  So the simplest thing is to presume that the standard
# system headers will be ok for this file.
$(objpfx)nscd_stat.o: sysincludes = # nothing
$(objpfx)selinux.o: sysincludes = # nothing
endif

LDLIBS-nscd = $(selinux-LIBS)

include ../Rules

CFLAGS-nscd_getpw_r.c += -fexceptions
CFLAGS-nscd_getgr_r.c += -fexceptions
CFLAGS-nscd_gethst_r.c += -fexceptions
CFLAGS-nscd_getai.c += -fexceptions
CFLAGS-nscd_initgroups.c += -fexceptions

ifeq (yesyes,$(have-fpie)$(build-shared))
CFLAGS-nscd += $(pie-ccflag)
endif

ifeq (yesyes,$(have-fpie)$(build-shared))
LDFLAGS-nscd = -Wl,-z,now
endif

# Set libof-nscd.
cpp-srcs-left := $(nscd-modules)
lib := nscd
include $(patsubst %,$(..)libof-iterator.mk,$(cpp-srcs-left))

$(objpfx)nscd: $(nscd-modules:%=$(objpfx)%.o)

ifeq ($(build-shared),yes)
$(objpfx)nscd: $(shared-thread-library)
else
$(objpfx)nscd: $(static-thread-library)
endif

=== posix/Makefile ===
# Copyright (C) 1991-2025 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <https://www.gnu.org/licenses/>.

#
#	Sub-makefile for POSIX portion of the library.
#
subdir	:= posix

include ../Makeconfig

headers := \
  bits/confname.h \
  bits/cpu-set.h \
  bits/environments.h \
  bits/getopt_core.h \
  bits/getopt_ext.h \
  bits/getopt_posix.h \
  bits/local_lim.h \
  bits/mman_ext.h \
  bits/posix1_lim.h \
  bits/posix2_lim.h \
  bits/posix_opt.h \
  bits/pthreadtypes-arch.h \
  bits/pthreadtypes.h \
  bits/sched.h \
  bits/spawn_ext.h \
  bits/thread-shared-types.h \
  bits/types.h \
  bits/types/idtype_t.h \
  bits/types/struct_sched_param.h \
  bits/typesizes.h \
  bits/unistd-decl.h \
  bits/unistd.h \
  bits/unistd_ext.h \
  bits/utsname.h \
  bits/waitflags.h \
  bits/waitstatus.h \
  cpio.h \
  fnmatch.h \
  getopt.h \
  glob.h \
  re_comp.h \
  regex.h \
  sched.h \
  spawn.h \
  sys/times.h \
  sys/types.h \
  sys/unistd.h \
  sys/utsname.h \
  sys/wait.h \
  tar.h \
  unistd.h \
  wait.h \
  wordexp.h \
  # headers

routines := \
  _Fork \
  _exit \
  alarm \
  bsd-getpgrp \
  confstr \
  execl \
  execle \
  execlp \
  execv \
  execve \
  execveat \
  execvp \
  execvpe \
  fexecve \
  fnmatch \
  fork \
  fpathconf \
  gai_strerror \
  get_child_max \
  getegid \
  geteuid \
  getgid \
  getgroups \
  getopt \
  getopt1 \
  getpgid \
  getpgrp \
  getpid \
  getppid \
  getresgid \
  getresuid \
  getsid \
  getuid \
  glob \
  glob-lstat-compat \
  glob64 \
  glob64-lstat-compat \
  glob64-time64 \
  glob_pattern_p \
  globfree \
  globfree64 \
  globfree64-time64 \
  group_member \
  nanosleep \
  pathconf \
  pause \
  posix_madvise \
  pread \
  pread64 \
  pwrite \
  pwrite64 \
  regex \
  register-atfork \
  sched_cpualloc \
  sched_cpucount \
  sched_cpufree \
  sched_getaffinity \
  sched_getp \
  sched_gets \
  sched_primax \
  sched_primin \
  sched_rr_gi \
  sched_setaffinity \
  sched_setp \
  sched_sets \
  sched_yield \
  setgid \
  setgroups \
  setpgid \
  setpgrp \
  setresgid \
  setresuid \
  setsid \
  setuid \
  shm-directory \
  sleep \
  spawn \
  spawn_faction_addchdir \
  spawn_faction_addclose \
  spawn_faction_addclosefrom \
  spawn_faction_adddup2 \
  spawn_faction_addfchdir \
  spawn_faction_addopen \
  spawn_faction_addtcsetpgrp_np \
  spawn_faction_destroy \
  spawn_faction_init \
  spawn_valid_fd \
  spawnattr_destroy \
  spawnattr_getdefault \
  spawnattr_getflags \
  spawnattr_getpgroup \
  spawnattr_getschedparam \
  spawnattr_getschedpolicy \
  spawnattr_getsigmask \
  spawnattr_init \
  spawnattr_setdefault \
  spawnattr_setflags \
  spawnattr_setpgroup \
  spawnattr_setschedparam \
  spawnattr_setschedpolicy \
  spawnattr_setsigmask \
  spawni \
  spawnp \
  streams-compat \
  sysconf \
  times \
  uname \
  vfork \
  wait \
  wait3 \
  wait4 \
  waitid \
  waitpid \
  wordexp \
  # routines

# Exclude fortified routines from being built with _FORTIFY_SOURCE
routines_no_fortify += \
  confstr \
  getgroups \
  pread \
  pread64 \
  # routines_no_fortify

aux := \
  environ \
  init-posix \
  # aux

tests := \
  bug-ga1 \
  bug-getopt1 \
  bug-getopt2 \
  bug-getopt3 \
  bug-getopt4 \
  bug-getopt5 \
  bug-glob2 \
  bug-glob3 \
  bug-regex1 \
  bug-regex2 \
  bug-regex3 \
  bug-regex4 \
  bug-regex6 \
  bug-regex7 \
  bug-regex8 \
  bug-regex9 \
  bug-regex10 \
  bug-regex11 \
  bug-regex12 \
  bug-regex13 \
  bug-regex14 \
  bug-regex15 \
  bug-regex16 \
  bug-regex17 \
  bug-regex18 \
  bug-regex19 \
  bug-regex21 \
  bug-regex22 \
  bug-regex23 \
  bug-regex24 \
  bug-regex25 \
  bug-regex26 \
  bug-regex27 \
  bug-regex28 \
  bug-regex29 \
  bug-regex30 \
  bug-regex31 \
  bug-regex32 \
  bug-regex34 \
  bug-regex35 \
  bug-regex36 \
  bug-regex37 \
  bug-regex38 \
  regexbug1 \
  runptests \
  runtests \
  test-errno \
  test-ssize-max \
  test-vfork \
  testfnm \
  transbug \
  tst-boost \
  tst-chmod \
  tst-cpucount \
  tst-cpuset \
  tst-dir \
  tst-execl1 \
  tst-execl2 \
  tst-execle1 \
  tst-execle2 \
  tst-execlp1 \
  tst-execlp2 \
  tst-execv1 \
  tst-execv2 \
  tst-execve1 \
  tst-execve2 \
  tst-execveat \
  tst-execvp1 \
  tst-execvp2 \
  tst-execvp3 \
  tst-execvp4 \
  tst-execvpe1 \
  tst-execvpe2 \
  tst-execvpe3 \
  tst-execvpe4 \
  tst-execvpe5 \
  tst-execvpe6 \
  tst-fexecve \
  tst-fnmatch \
  tst-fnmatch2 \
  tst-fnmatch3 \
  tst-fnmatch4 \
  tst-fnmatch5 \
  tst-fnmatch6 \
  tst-fnmatch7 \
  tst-fork \
  tst-gai_strerror \
  tst-getopt_long1 \
  tst-glob-tilde \
  tst-glob_symlinks \
  tst-gnuglob \
  tst-gnuglob64 \
  tst-mmap \
  tst-mmap-offset \
  tst-nanosleep \
  tst-nice \
  tst-pathconf \
  tst-pcre \
  tst-posix_fadvise \
  tst-posix_fadvise64 \
  tst-posix_spawn-fd \
  tst-posix_spawn-setsid \
  tst-preadwrite \
  tst-preadwrite64 \
  tst-regcomp-truncated \
  tst-regex \
  tst-regex2 \
  tst-regexloc \
  tst-rxspencer \
  tst-rxspencer-no-utf8 \
  tst-sched_getaffinity \
  tst-spawn-chdir \
  tst-spawn4 \
  tst-spawn5 \
  tst-spawn6 \
  tst-spawn7 \
  tst-sysconf \
  tst-sysconf-empty-chroot \
  tst-truncate \
  tst-truncate64 \
  tst-vfork1 \
  tst-vfork2 \
  tst-wait3 \
  tst-wait4 \
  tst-waitid \
  tst-wordexp-nocmd \
  tstgetopt \
  # tests

# Test for the glob symbol version that was replaced in glibc 2.27.
ifeq ($(have-GLIBC_2.26)$(build-shared),yesyes)
tests += \
  tst-glob_lstat_compat
  # tests
endif

# Test for the posix_spawn, posix_spawnp symbol versions replaced in
# glibc 2.15.
ifeq ($(have-GLIBC_2.14)$(build-shared),yesyes)
tests += \
  tst-spawn4-compat \
  # tests
endif

tests-internal := \
  bug-regex5 \
  bug-regex20 \
  bug-regex33 \
  # tests-internal

tests-container := \
  bug-ga2 \
  tst-vfork3 \
  # tests-container

tests-time64 := \
  tst-gnuglob64-time64 \
  tst-wait3-time64 \
  tst-wait4-time64 \
  # tests-time64

xtests := \
  tst-sched_rr_get_interval \
  # xtests

xtests-time64 := \
  tst-sched_rr_get_interval-time64 \
  # xtests-time64

ifeq (yes,$(build-shared))
test-srcs := \
  globtest
  # tests-src
tests += \
  tst-exec \
  tst-spawn \
  tst-spawn2 \
  tst-spawn3 \
  wordexp-test \
  # tests
endif

ifeq (yesyes,$(build-shared)$(have-thread-library))
tests += \
  tst-_Fork \
  tst-getopt-cancel \
  # tests
endif

tests-static = \
  tst-exec-static \
  tst-spawn-static \
  # tests-static

tests += \
  $(tests-static)
  # tests

others := \
  getconf \
  # others

install-bin := \
  getconf \
  # getconf

install-others-programs := \
  $(inst_libexecdir)/getconf \
  # install-others-programs

before-compile += \
  $(objpfx)posix-conf-vars-def.h \
  # before-compile

# So they get cleaned up.
generated += \
  $(addprefix wordexp-test-result, 1 2 3 4 5 6 7 8 9 10) \
  annexc \
  annexc.out \
  getconf.speclist \
  ptestcases.h \
  testcases.h \
  tst-getconf.out \
  wordexp-tst.out \
  # generated

ifeq ($(run-built-tests),yes)
ifeq (yes,$(build-shared))
ifneq ($(PERL),no)
generated += \
  bug-ga2-mem.out \
  bug-ga2.mtrace \
  bug-glob2-mem.out \
  bug-glob2.mtrace \
  bug-regex14-mem.out \
  bug-regex14.mtrace \
  bug-regex2-mem.out \
  bug-regex2.mtrace \
  bug-regex21-mem.out \
  bug-regex21.mtrace \
  bug-regex31-mem.out \
  bug-regex31.mtrace \
  bug-regex36-mem.out \
  bug-regex36.mtrace \
  tst-boost-mem.out \
  tst-boost.mtrace \
  tst-fnmatch-mem.out \
  tst-fnmatch.mtrace \
  tst-pcre-mem.out \
  tst-pcre.mtrace \
  tst-rxspencer-no-utf8-mem.out \
  tst-rxspencer-no-utf8.mtrace \
  tst-vfork3-mem.out \
  tst-vfork3.mtrace \
  # generated
endif
endif
endif

ifeq ($(run-built-tests),yes)
ifeq (yes,$(build-shared))
tests-special += \
  $(objpfx)globtest.out \
  $(objpfx)wordexp-tst.out \
  # tests-special
endif
endif

# Run a test on the header files we use.
# XXX Please note that for now we ignore the result of this test.
tests-special += $(objpfx)annexc.out
ifeq ($(run-built-tests),yes)
tests-special += $(objpfx)tst-getconf.out
ifeq (yes,$(build-shared))
ifneq ($(PERL),no)
tests-special += \
  $(objpfx)bug-ga2-mem.out \
  $(objpfx)bug-glob2-mem.out \
  $(objpfx)bug-regex14-mem.out \
  $(objpfx)bug-regex2-mem.out \
  $(objpfx)bug-regex21-mem.out \
  $(objpfx)bug-regex31-mem.out \
  $(objpfx)bug-regex36-mem.out \
  $(objpfx)tst-boost-mem.out \
  $(objpfx)tst-fnmatch-mem.out \
  $(objpfx)tst-glob-tilde-mem.out \
  $(objpfx)tst-pcre-mem.out \
  $(objpfx)tst-rxspencer-no-utf8-mem.out \
  $(objpfx)tst-vfork3-mem.out \
  # tests-special
endif
endif
endif

include ../Rules

ifeq ($(run-built-tests),yes)
# globtest and wordexp-test currently only works with shared libraries
ifeq (yes,$(build-shared))
$(objpfx)globtest.out: globtest.sh $(objpfx)globtest
	$(SHELL) $< $(common-objpfx) '$(test-via-rtld-prefix)' \
		'$(test-program-prefix)' '$(test-wrapper-env)'; \
	$(evaluate-test)
$(objpfx)wordexp-tst.out: wordexp-tst.sh $(objpfx)wordexp-test
	$(SHELL) $< $(common-objpfx) '$(test-program-prefix-before-env)' \
		 '$(run-program-env)' '$(test-program-prefix-after-env)'; \
	$(evaluate-test)
endif

LOCALES := \
  C.UTF-8 \
  cs_CZ.ISO-8859-2 \
  cs_CZ.UTF-8 \
  da_DK.ISO-8859-1 \
  de_DE.ISO-8859-1 \
  de_DE.UTF-8 \
  en_US.UTF-8 \
  es_US.ISO-8859-1 \
  es_US.UTF-8 \
  ja_JP.EUC-JP \
  tr_TR.UTF-8 \
  # LOCALES
include ../gen-locales.mk

$(objpfx)bug-regex1.out: $(gen-locales)
$(objpfx)bug-regex4.out: $(gen-locales)
$(objpfx)bug-regex5.out: $(gen-locales)
$(objpfx)bug-regex6.out: $(gen-locales)
$(objpfx)bug-regex17.out: $(gen-locales)
$(objpfx)bug-regex18.out: $(gen-locales)
$(objpfx)bug-regex19.out: $(gen-locales)
$(objpfx)bug-regex20.out: $(gen-locales)
$(objpfx)bug-regex22.out: $(gen-locales)
$(objpfx)bug-regex23.out: $(gen-locales)
$(objpfx)bug-regex25.out: $(gen-locales)
$(objpfx)bug-regex26.out: $(gen-locales)
$(objpfx)bug-regex30.out: $(gen-locales)
$(objpfx)bug-regex32.out: $(gen-locales)
$(objpfx)bug-regex33.out: $(gen-locales)
$(objpfx)bug-regex34.out: $(gen-locales)
$(objpfx)bug-regex35.out: $(gen-locales)
$(objpfx)tst-fnmatch.out: $(gen-locales)
$(objpfx)tst-fnmatch4.out: $(gen-locales)
$(objpfx)tst-fnmatch5.out: $(gen-locales)
$(objpfx)tst-fnmatch6.out: $(gen-locales)
$(objpfx)tst-regex.out: $(gen-locales)
$(objpfx)tst-regex2.out: $(gen-locales)
$(objpfx)tst-regexloc.out: $(gen-locales)
$(objpfx)tst-rxspencer.out: $(gen-locales)
$(objpfx)tst-rxspencer-no-utf8.out: $(gen-locales)
$(objpfx)tst-regcomp-truncated.out: $(gen-locales)
endif

# If we will use the generic uname implementation, we must figure out what
# it will say by examining the system, and write the results in config-name.h.
uname.c: $(objpfx)config-name.h
$(objpfx)config-name.h: $(..)scripts/config-uname.sh $(common-objpfx)config.make
	$(make-target-directory)
	$< '$(config-os)' '$(config-release)' \
	   '$(config-machine)-$(config-vendor)' > $@.new
	mv -f $@.new $@

CFLAGS-pause.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-pread.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-pread64.c += -fexceptions -fasynchronous-unwind-tables $(config-cflags-wno-ignored-attributes)
CFLAGS-pwrite.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-pwrite64.c += -fexceptions -fasynchronous-unwind-tables $(config-cflags-wno-ignored-attributes)
CFLAGS-sleep.c += -fexceptions
CFLAGS-wait.c += -fexceptions -fasynchronous-unwind-tables
CFLAGS-waitid.c += -fexceptions -fasynchronous-unwind-tables

=== debian/changelog ===
glibc (2.41-12) unstable; urgency=medium

  [ Helmut Grohne ]
  * debian/debhelper.in/libc.postinst: Don't restart systemd when it does not
    work.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 05 Aug 2025 19:34:49 +0200

glibc (2.41-11) unstable; urgency=medium

  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix iconv to not create executable files with -o.
    - Fix double-free after allocation failure in regcomp (GLIBC-SA-2025-0005
      / CVE-2025-8058).  Closes: #1109803.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 26 Jul 2025 20:29:12 +0200

glibc (2.41-10) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: Update xfails.
  * debian/patches/hurd-i386/local-pthread_once.diff: Pave the way for 2.42.

  [ Helmut Grohne ]
  * Partially restore init restarting. (Closes: #1108193)

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix sparc32 Fix argument passing to __libc_start_main
    - Fix error reporting (false negatives) in SGID tests

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 17 Jul 2025 13:21:32 +0200

glibc (2.41-9) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix loading TLS-using modules using LD_AUDIT.
    - Add tests for CVE-2025-4802.
    - Fix swapped wcsncpy and wcpncpy function names in IFUNC definition.
    - Fix elf/tst-execstack-prog-static-tunable on sparc64.
    - Remove POWER10 optimized strcmp function (GLIBC-SA-2025-0003 /
      CVE-2025-5702).  Closes: #1107365.
    - Remove POWER10 optimized strncmp function (GLIBC-SA-2025-0004 /
      CVE-2025-5745).  Closes: #1107366.
    - Remove POWER10 optimized memchr function.

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-rename.diff: Make rename refuse trailing
    slashes.
  * debian/patches/hurd-i386/local-64b-align.diff: Avoid 64b typing error on
    RPCs using 64b fields in structures.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 18 Jun 2025 06:49:31 +0200

glibc (2.41-8) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: xfail tst-execstack-prog-static-tunable
    on hurd-any. Drop duplicate unsupported stances commited uptream.
  * debian/patches/hurd-i386/git-dup-refcnt.diff: Fix detecting too many dups.
  * debian/patches/hurd-i386/git-xstate.diff: Fix restoring SSE state on
    signals.
  * debian/patches/hurd-i386/local-intr-msg-clobber.diff: Drop now-useless
    patch.
  * debian/patches/hurd-i386/git-utime-EINVAL.diff: Make *utime*s catch invalid
    times.
  * debian/patches/hurd-i386/git-xstate-initialized.diff: Fix crash in dash.
  * debian/patches/hurd-i386/git-signal-fpe-exceptions.diff: Fix crash in FPE
    handlers.
  * debian/patches/hurd-i386/git-symlink-eexist.diff: Fix gnulib testsuite.

  [ Adriano Rafael Gomes ]
  * Update Brazilian Portuguese debconf translation.  Closes: #1103446.

  [ Aurelien Jarno ]
  * debian/rules.d/debhelper.mk: do not replace LIBC in debhelper.in files.
    This was used for lintian overrides, but it is not used anymore.  Closes:
    #1104099.
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix elf/tst-audit10 test failure on x86 systems without AVX.  Closes:
      #1103303.
    - Fix pthread_getattr_np failure when executable stack tunable is set.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 17 May 2025 17:15:43 +0200

glibc (2.41-7) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-pthread_setcancel.diff: Fix tst-cond32.

  [ Atila KOÇ ]
  * Update Turkish debconf translation.  Closes: #1101162.

  [ Remus-Gabriel Chelu ]
  * Update Romanian debconf translation.  Closes: #1101814.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Build a FMA version of atanh, sinh and tanh functions using IFUNC on
      amd64.
    - Fix a crash on amd64 when disabling XSAVEC through the glibc.cpu.hwcaps
      tunable.
    - Extend glibc.rtld.execstack tunable to force executable stack.
    - Detect Intel Arrow Lake, Panther Lake, Clearwater Forest, and Diamond
      Rapids CPUs.
    - Handle unknown Intel processors with default tuning.
  * debhelper.in/libc.NEWS: add an entry to describe the executable stack
    change and provide workaround.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 13 Apr 2025 21:40:49 +0200

glibc (2.41-6) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/rules.d/build.mk: Fix missing library-path to get just-built
    libmachuser and libhurduser.
  * debian/patches/hurd-i386/git-rt-timedwait-realtime.diff: Fix aio_suspend
    delay.

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 14 Mar 2025 23:56:28 +0100

glibc (2.41-5) unstable; urgency=medium

  [ Pedro Ribeiro ]
  * Update Portuguese translation.  Closes: #1100065.

  [ Bjarni Ingi Gislason ]
  * debian/local/manpages/gencat.1: editorial fixes.  Closes: #1100190.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix race condition between pthread_cancel() and pthread_setcanceltype()
      affecting PARI/GP.  Closes: #1099624.
  * debian/control.in/libc: add more conflicts against shared libraries with
    executable stack.

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 14 Mar 2025 21:07:20 +0100

glibc (2.41-4) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/control.in/libc: change breaks against postgresql-15-pllua to the
    fixed version available in apt.postgresql.org.  Closes: #1099197.
  * debian/control.in/libc: add more conflicts against shared libraries with
    executable stack.
  * debian/tests/upstream-testsuite: disable biarch testsuite for i386
    autopkgtest as the i386 debci runners are not powerful to run all the
    testsuites within the default timeout.
  * debian/patches/git-updates.diff: update from upstream stable branch:


=== debian/control ===
Source: glibc
Section: libs
Priority: required
Build-Depends: gettext, dpkg (>= 1.18.7), dpkg-dev (>= 1.17.14), xz-utils, file, quilt,
 autoconf, gawk, debhelper-compat (= 13), rdfind, symlinks, netbase, gperf, bison,
 linux-libc-dev (>= 3.9) [linux-any],
 libaudit-dev [linux-any], libcap-dev [linux-any] <!stage2>, libselinux1-dev [linux-any] <!stage2>,
 mig-for-host (>= 1.8+git20200618-7~) [hurd-any], gnumach-dev (>= 2:1.8+git20200710-2~) [hurd-any],
 hurd-dev (>= 1:0.9.git20201127-4~) [hurd-any] | hurd-headers-dev [hurd-any],
 binutils-for-host (>= 2.38),
 g++-14-for-host, g++-14-multilib [amd64 i386 mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el powerpc ppc64 s390x sparc sparc64 x32] <!nobiarch>,
 g++-14-for-host (>= 14.1.0-4) [arm64],
 python3:native,
 libidn2-0 (>= 2.0.5~) <!nocheck>,
 libc-bin (>= 2.41) <cross>,
 libgd-dev <!stage1 !stage2>,
Build-Depends-Indep: perl, po-debconf (>= 1.0)
Rules-Requires-Root: no
Maintainer: GNU Libc Maintainers <debian-glibc@lists.debian.org>
Uploaders: Clint Adams <clint@debian.org>, Aurelien Jarno <aurel32@debian.org>, Samuel Thibault <sthibault@debian.org>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/glibc-team/glibc
Vcs-Git: https://salsa.debian.org/glibc-team/glibc.git
Homepage: https://www.gnu.org/software/libc/libc.html

Package: libc-bin
Architecture: any
Section: libs
Priority: required
Essential: yes
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: dh-lua (<< 27+nmu1~)
Recommends: manpages
Build-Profiles: <!stage1>
Description: GNU C Library: Binaries
 This package contains utility programs related to the GNU C Library.
 .
  * getconf: query system configuration variables
  * getent: get entries from administrative databases
  * iconv, iconvconfig: convert between character encodings
  * ldd, ldconfig: print/configure shared library dependencies
  * locale, localedef: show/generate locale definitions
  * tzselect, zdump, zic: select/dump/compile time zones

Package: libc-dev-bin
Architecture: any
Section: libdevel
Priority: optional
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: manpages, manpages-dev
Suggests: libc-devtools (>> 2.41)
Build-Profiles: <!stage1>
Description: GNU C Library: Development binaries
 This package contains utility programs related to the GNU C Library
 development package.
 .
  * gencat: generate message catalogs

Package: libc-devtools
Architecture: any
Section: devel
Priority: optional
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libc-dev-bin (<< 2.31-8)
Replaces: libc-dev-bin (<< 2.31-8)
Recommends: libc-dev (= ${binary:Version}), manpages, manpages-dev
Build-Profiles: <!stage1> <!stage2>
Description: GNU C Library: Development tools
 This package contains development tools shipped by the GNU C
 Library.
 .
  * memusage, memusagestat: profile a program's memory usage
  * mtrace: interpret the malloc trace log
  * sotruss: trace shared library calls
  * sprof: display shared object profiling data

Package: libc-l10n
Architecture: all
Section: localization
Priority: standard
Multi-Arch: foreign
Depends: ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: localization files
 This package contains the translation files for the GNU C library and
 utility programs.

Package: glibc-doc
Architecture: all
Section: doc
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: glibc-doc-reference
Build-Profiles: <!stage1>
Description: GNU C Library: Documentation
 Contains the complete GNU C Library ChangeLog.  The GNU C Library Reference
 manual has been moved into glibc-doc-reference for licensing reasons.

Package: glibc-source
Architecture: all
Section: devel
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: xz-utils
Build-Profiles: <!stage1>
Description: GNU C Library: sources
 This package contains the sources and patches which are needed to
 build glibc.

Package: locales
Architecture: all
Section: localization
Priority: standard
Depends: libc-bin (>> 2.41), libc-l10n (>> 2.41), ${misc:Depends}, debconf | debconf-2.0
Build-Profiles: <!stage1>
Description: GNU C Library: National Language (locale) data [support]
 Machine-readable data files, shared objects and programs used by the
 C library for localization (l10n) and internationalization (i18n) support.
 .
 This package contains tools to generate locale definitions from source
 files (included in this package). It allows you to customize which
 definitions actually get generated. This is a space-saver over how this
 package used to be, with all locales generated by default. This created
 a package that unpacked to an excess of 30 megs.

Package: locales-all
Architecture: any
Section: localization
Priority: optional
Multi-Arch: foreign
Depends: libc-l10n (>> 2.41), ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Precompiled locale data
 This package contains the precompiled locale data for all supported locales.
 A better alternative is to install the locales package and only select
 desired locales, but it can be useful on a low-memory machine because some
 locale files take a lot of memory to be compiled.

Package: nscd
Architecture: any
Section: admin
Multi-Arch: foreign
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Conflicts: unscd
Build-Profiles: <!stage1>
Description: GNU C Library: Name Service Cache Daemon
 A daemon which handles passwd, group and host lookups
 for running programs and caches the results for the next
 query. You should install this package only if you use
 slow services like LDAP, NIS or NIS+.

Package: libc6
Architecture: amd64 arc arm64 armel armhf hppa i386 loong64 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: libs
Priority: optional
Multi-Arch: same
Depends: ${shlibs:Depends}, ${libgcc:Depends}
Recommends: libidn2-0 (>= 2.0.5~)
Suggests: glibc-doc, debconf | debconf-2.0, libc-l10n, locales [!hurd-any], libnss-nis, libnss-nisplus
Provides: libc6-sparcv9b [sparc sparc64], libc0.3-i686 [hurd-i386], libc6-i686 [i386]
Conflicts: libc6-i686 [i386], libc6.1-alphaev67 [alpha]
Breaks: nscd (<< 2.41), locales (<< 2.41), locales-all (<< 2.41), gnumach-image-1.8-486 (<< 2:1.8+git20210923~), gnumach-image-1.8-486-dbg (<< 2:1.8+git20210923~), gnumach-image-1.8-xen-486 (<< 2:1.8+git20210923~), gnumach-image-1.8-xen-486-dbg (<< 2:1.8+git20210923~), hurd (<< 1:0.9.git20220301-2), python3-iptables (<< 1.0.0-2), fakechroot (<< 2.19-3.5), tinydns (<< 1:1.05-14), chrony (<< 4.2-3~), valgrind (<< 1:3.19.0-1~), firefox (<< 91~), firefox-esr (<< 91~), sysvinit-core (<< 3.09-2~), sysvinit (<< 3.09-2~), base-files (<< 13.3~), openssh-server (<< 1:9.9p1-3+hurd.1) [hurd-amd64], dhcpcd (<< 1:10.1.0-7~), pd-scaf (<< 1:0.14.1+darcs20180201-6+b4), postgresql-15-pllua (<< 1:2.0.12-4), postgresql-17-pllua (<< 1:2.0.12-3+b2), librccl1 (<< 5.4.3-3+b1), libamdhip64-5 (<< 5.7.1-5+b1), libhiprtc-builtins5 (<< 5.7.1-5+b1), lua-swupdate (<< 2024.12.1+dfsg-1+b3), libswupdate0.1 (<< 2024.12.1+dfsg-1+b3), uwsgi-plugin-pypy3 (<< 0.0.2+b1), python3-onnxruntime (<< 1.20.1+dfsg-2~), libde265-0 (<< 1.0.15-1+b3) [armel armhf], libmad0 (<< 0.15.1b-11+b1) [armel armhf], libx264-164 (<< 2:0.164.3108+git31e19f9-2+b1) [armel armhf], doublecmd-gtk (<< 1.1.22-1+b1) [armel armhf], doublecmd-plugins (<< 1.1.22-1+b1) [armel armhf], doublecmd-qt (<< 1.1.22-1+b1) [armel armhf], libmpeg2-4 (<<  0.5.1-9+b3) [armel armhf], libne10-10t64 (<< 1.2.1-5.1+b2) [armhf], libpdbg5 (<< 3.5-1+b1) [armel], libopenblas0-openmp (<< 0.3.29+ds-2+b1) [armhf s390x], libopenblas0-pthread (<< 0.3.29+ds-2+b1) [armhf s390x], libopenblas0-serial (<< 0.3.29+ds-2+b1) [armhf s390x], libopenblas64-0-openmp (<< 0.3.29+ds-2+b1) [s390x], libopenblas64-0-pthread (<< 0.3.29+ds-2+b1) [s390x], libopenblas64-0-serial (<< 0.3.29+ds-2+b1) [s390x], libfec0 (<< 1.0-26-gc5d935f-1+b3) [i386], python3-mrgingham (<< 1.25-1), linux-perf (<< 6.12.16-1) [armel], libqt6webenginecore6 (<< 6.8.2+dfsg-3) [i386]
Replaces: libc6-amd64 [amd64],
          libc6-i386 [i386],
          libc0.3-i686 [hurd-i386],
          libc6-i686 [i386],
          libc6-x32 [x32],
          libc6-powerpc [powerpc],
          libc6-ppc64 [ppc64],
          libc6-s390x [s390x],
          libc6-sparc64 [sparc64],
          libc6-mips64 [mips64 mips64el],
          libc6-mipsn32 [mipsn32 mipsn32el],
          libc6-mips32 [mips mipsel],
          hurd (<< 20120408-3) [hurd-i386]
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.

Package: libc6-dev
Architecture: amd64 arc arm64 armel armhf hppa i386 loong64 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64r6 mips64r6el nios2 powerpc ppc64 ppc64el riscv64 sparc sparc64 s390x sh3 sh4 x32
Section: libdevel
Priority: optional
Multi-Arch: same
Depends: libc6 (= ${binary:Version}) <!stage1>, libc-dev-bin (= ${binary:Version}), ${misc:Depends}, linux-libc-dev [linux-any], gnumach-dev [hurd-any], hurd-dev (>= 20080607-3) [hurd-any] | hurd-headers-dev [hurd-any], ${libcrypt-dev:Depends}, ${rpcsvc-proto:Depends}
Replaces: hurd-dev (<< 20120408-3) [hurd-any], libc6 (<= 2.32-1)
Suggests: glibc-doc, manpages-dev
Provides: libc-dev (= ${binary:Version}), libc6-dev [alpha hurd-any]

=== debian/rules ===
#! /usr/bin/make -f
# -*- makefile -*-
# debian/rules file for GNU libc.
# Copyright 1998, 1999 by Joel Klecker <espy@debian.org>
# Copyright 2000-2004 Ben Collins <bcollins@debian.org>
# Copyright 2002-2004 Jeff Bailey <jbailey@debian.org>
# Copyright 2002-2005 Philip Blundell <pb@debian.org>
# Copyright 2002-2006 Daniel Jacobowitz <dan@debian.org>
# Copyright 2002-2006 GOTO Masanori <gotom@debian.org>
# Copyright 2006 Denis Barbier <barbier@debian.org>
# Copyright 2006-2025 Aurelien Jarno <aurel32@debian.org>
# Copyright 2007-2008 Pierre Habouzit <madcoder@debian.org>
# Copyright 2010-2013 Clint Adams <clint@debian.org>
# Copyright 2012-2019 Adam Conrad <adconrad@0c3.net>
# Copyright 2016-2025 Samuel Thibault <sthibault@debian.org>
# This Makefile is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# What are the phases to building glibc?

# Unpack main tarball
# Do any necessary overlays
# Apply patches
# Determine how many builds there are to do.  For Each build:

#  Create build directory
#  Configure
#  Build
#  Test as desired
#  Install to package directories

# Run debian magic to build packages.

# Things you may need to customise:

# These are done as absolute paths so that in the case of filesystem size
# limitations, they can be overridden and spread all over.
build-tree := build-tree
debian-tmp = debian/tmp$(filter-out -libc,-$(curpass))
stamp := $(CURDIR)/stamp-dir/
DUMMY := $(shell mkdir -p $(stamp))

# Beyond here you shouldn't need to customise anything:
DEB_HOST_ARCH         ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_CPU     ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_HOST_ARCH_ENDIAN  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE     ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH    ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_BUILD_ARCH        ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_BUILD_ARCH_BITS   ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_BITS)
DEB_BUILD_GNU_TYPE    ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

include /usr/share/dpkg/pkg-info.mk

# The minimum package version with which these packages are compatible.
shlib_dep_ver = $(DEB_VERSION_UPSTREAM)
shlib_dep = $(libc) (>= $(shlib_dep_ver))

DEB_BUILDDIR ?= $(build-tree)/$(DEB_HOST_ARCH)-$(curpass)
DEB_BUILDDIRLIBC ?= $(build-tree)/$(DEB_HOST_ARCH)-libc

GLIBC_SOURCES = $(filter-out debian $(shell basename $(stamp)) $(build-tree), $(wildcard *))

# Support multiple makes at once based on number of processors
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# use the package settings, not the settings from the environment
define unsetenv
  unexport $(1)
  $(1) =
endef
$(foreach v, CPPFLAGS CFLAGS CXXFLAGS LDFLAGS, $(if $(filter environment,$(origin $(v))),$(eval $(call unsetenv, $(v)))))

# export debhelper substitution variables
export $(build-tree)

# Default setup
GLIBC_PASSES ?= libc

prefix=/usr
bindir=$(prefix)/bin
datadir=$(prefix)/share
complocaledir=$(prefix)/lib/locale
sysconfdir=/etc
libexecdir=$(prefix)/lib
rootsbindir=/sbin
includedir=$(prefix)/include
docdir=$(prefix)/share/doc
mandir=$(prefix)/share/man
sbindir=$(prefix)/sbin
vardbdir=/var/lib/misc
rtlddir=/lib
slibdir=/lib/$(DEB_HOST_MULTIARCH)
libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
mvec = no

rtld_so=$(shell awk 'BEGIN {FS="="} /^ld\.so-version/ {print $$2}' $(DEB_BUILDDIR)/soversions.mk)
rtld_target=$(shell readlink $(debian-tmp)$(rtlddir)/$(rtld_so))
libc_so=$(shell awk 'BEGIN {FS="="} /^libc\.so-version/ {print "libc.so"$$2}' $(DEB_BUILDDIR)/soversions.mk)

BASE_CC = gcc
BASE_CXX = g++
BASE_MIG = mig
# If you override DEB_GCC_VERSION, consider adding DEB_CFLAGS_APPEND=-Wno-error.
DEB_GCC_VERSION ?= -14

RUN_TESTSUITE = yes
TIMEOUTFACTOR = 25

# Set cross and native compiler names, including version.
CC     = $(DEB_HOST_GNU_TYPE)-$(BASE_CC)$(DEB_GCC_VERSION)
CXX    = $(DEB_HOST_GNU_TYPE)-$(BASE_CXX)$(DEB_GCC_VERSION)
MIG    = $(DEB_HOST_GNU_TYPE)-$(BASE_MIG)
BUILD_CC = $(DEB_BUILD_GNU_TYPE)-$(BASE_CC)
BUILD_CXX = $(DEB_BUILD_GNU_TYPE)-$(BASE_CXX)

BUILD_CFLAGS = -O2 -g -fdebug-prefix-map=$(CURDIR)=.
HOST_CFLAGS = -pipe -O2 -g -fdebug-prefix-map=$(CURDIR)=. $(call xx,extra_cflags)

# 32-bit MIPS builders have a 2GB memory space. This is not enough to
# build test-tgmath3.o with GCC, unless tweaking the garbage collector.
ifeq ($(findstring mips,$(DEB_BUILD_ARCH))-$(DEB_BUILD_ARCH_BITS), mips-32)
  CC += --param ggc-min-expand=10
endif

configure_target := $(DEB_HOST_GNU_TYPE)

# Normally we'll just use this for --build.  If the architecture requires
# that build daemons be able to run a particular optimized library, then
# they can set the --build to match --host for that optimized build.
# Among other things this lets tests run.
configure_build := $(DEB_BUILD_GNU_TYPE)

# Which build pass are we on?
curpass = $(filter-out %_,$(subst _,_ ,$@))

ifneq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
  DEB_ARCH_REGULAR_PACKAGES = $(libc)-dev
  DEB_INDEP_REGULAR_PACKAGES =
  DEB_UDEB_PACKAGES =
  ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
    DEB_BUILD_OPTIONS+=nocheck
  endif
else
  DEB_ARCH_REGULAR_PACKAGES = $(libc) $(libc)-dev $(libc)-dbg libc-bin libc-dev-bin
  ifeq ($(filter stage2,$(DEB_BUILD_PROFILES)),)
    DEB_ARCH_REGULAR_PACKAGES += libc-devtools
  endif
  DEB_INDEP_REGULAR_PACKAGES = glibc-doc glibc-source libc-l10n locales
  ifneq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
    DEB_UDEB_PACKAGES =
  else
    DEB_UDEB_PACKAGES = $(libc)-udeb
  endif
  ## Locales can only be pre-generated during native compiles
  ifeq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
    DEB_ARCH_REGULAR_PACKAGES += locales-all
  endif
endif

# Generic kernel version check
define kernel_check
(if [ $(CURRENT_KERNEL_VERSION) -lt $(1) ]; then \
  false; \
fi)
endef

# Include libidn for both NPTL and FBTL targets.
standard-add-ons = libidn,

# Pull in all the per-arch magic!

-include debian/sysdeps/$(DEB_HOST_ARCH_OS).mk
-include debian/sysdeps/$(DEB_HOST_ARCH).mk

ifneq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
DEB_ARCH_REGULAR_PACKAGES += $(foreach p,$(DEB_ARCH_MULTILIB_PACKAGES), $(if $(findstring -dev,$(p)), $(p)))
else
DEB_ARCH_REGULAR_PACKAGES += $(DEB_ARCH_MULTILIB_PACKAGES)
endif

# Don't run dh_strip on this package
NOSTRIP_$(libc)-dbg = 1

# Put the debug files from these packages in $(libc)-dbg
DEBUG_$(libc) = 1

ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
  ifeq ($(threads),yes)
  DEB_ARCH_REGULAR_PACKAGES += nscd
  endif
endif

# And now the rules...
include debian/rules.d/*.mk

clean:: unpatch
	rm -rf $(patsubst %,debian/tmp-%,$(GLIBC_PASSES))
	rm -rf $(build-tree)
	rm -rf $(stamp)
	rm -rf debian/include
	rm -f debian/control.in/libc0.3	debian/control.in/libc6 debian/control.in/libc6.1 \
		debian/*.preinst.* debian/*.links.*

# Required Debian targets
build-arch: $(stamp)info \
	$(patsubst %,$(stamp)build_%,$(GLIBC_PASSES)) \
	$(patsubst %,$(stamp)check_%,$(GLIBC_PASSES)) \
	build-arch-post-check

ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
build-arch: $(stamp)build_C.utf8 \
	$(stamp)build_locales-all
endif

build-indep: $(stamp)source $(stamp)build_libc

build: build-arch build-indep


binary-indep: build-indep testroot debian/control $(build-tree) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_INDEP_REGULAR_PACKAGES))

binary-arch: build-arch testroot debian/control $(build-tree) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_ARCH_REGULAR_PACKAGES)) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_UDEB_PACKAGES))

binary: binary-indep binary-arch

testroot:
	dh_testroot

=== debian/tests/control ===
Tests: upstream-testsuite
Depends: @builddeps@, binutils, linux-libc-dev [linux-any], gcc-14
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="mode=git, gitmode=shallow, pgpmode=none" \
https://sourceware.org/git/glibc.git refs/tags/glibc-(\d+\.\d+(?:\.\d{1,2})?)$ debian
